﻿;{ ==Code Header Comment==============================
;        Name/title: DrawArc.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of arcs on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawArc
  
 Declare NewArc()
 Declare AddElements()
  
EndDeclareModule

Module DrawArc

  Global Window_0

  Global spnSize, btnColour
    
  Global Thickness.i, Transparency.i
  
  Global DrawAction.i = -1    
 
  Procedure Process(x.i,y.i)
    ;{ Procedure that takes the current x,y co-ordinates and
    ;The current drawaction to represent and display the arc on the canvas
    ;}
    Static CentreX.i,CentreY.i,Radius.i,Angle1.i,Angle2.i 
    
    If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
    
      ;Clearcanvas to the drawn image
      DrawVectorImage(ImageID(AppMain::DrawnImg), 255)

      Select DrawAction
        Case 0
            
          CentreX = X
          CentreY = Y 
            
        Case 1 ;Start Point Chosen so chose radius and centre point
          
          AppMain::NewObject\OuterRadius = Sqr(Pow((CentreX-X),2) + Pow((CentreY-Y),2))
          VectorSourceColor(RGBA($FF,$00,$00,$FF))
          AddPathCircle(X,Y, AppMain::NewObject\OuterRadius , 0,360)
          DashPath(1, 5)        

        Case 2 ;Start Point And radius now get start Angle
     
          VectorSourceColor(RGBA($00,$FF,$00,$FF))
          AddPathCircle(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\OuterRadius , 0,360)     
          StrokePath(1)   
            
          ;Show Chose angle line           
          VectorSourceColor(RGBA($FF,$00,$00,$FF))
          MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
          AddPathLine(x,y)
          DashPath(1, 5)
            
          If x => AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
            If X - AppMain::NewObject\StartX = 0
              Angle1 = 90
            Else
              Angle1 = Degree(ATan((Y - AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
            EndIf
          ElseIf  x =< AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
            If Y-AppMain::NewObject\StartY = 0
              Angle1 = 180
            Else
              Angle1 = 90 + Degree(ATan((AppMain::NewObject\StartX-X)/(Y-AppMain::NewObject\StartY)))
            EndIf
          ElseIf  x =< AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY
            If X - AppMain::NewObject\StartX = 0
              Angle1 = 270
            Else
              Angle1 = 180 + Degree(ATan((Y-AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
            EndIf
          ElseIf  x => AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY  
            Angle1 = 270 + Degree(ATan((X - AppMain::NewObject\StartX)/(AppMain::NewObject\StartY-Y)))
          EndIf
          AppMain::NewObject\StartAngle = Angle1
            
        Case 3 ;Get End Angle
            
          VectorSourceColor(RGBA($00,$FF,$00,$FF))
          AddPathCircle(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\OuterRadius , 0,360)     
          StrokePath(1) 
            
          ;Show Chose angle line           
          VectorSourceColor(RGBA($FF,$00,$00,$FF))
          MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
          AddPathLine(x,y)
          DashPath(1, 5)
            
          If x => AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
            If X - AppMain::NewObject\StartX = 0
              Angle2 = 90
            Else
              Angle2 = Degree(ATan((Y - AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
            EndIf
          ElseIf  x =< AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
            If Y-AppMain::NewObject\StartY = 0
              Angle2 = 180
            Else
              Angle2 = 90 + Degree(ATan((AppMain::NewObject\StartX-X)/(Y-AppMain::NewObject\StartY)))
            EndIf
          ElseIf  x =< AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY
            If X - AppMain::NewObject\StartX = 0
              Angle2 = 270
            Else
              Angle2 = 180 + Degree(ATan((Y-AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
            EndIf
          ElseIf  x => AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY  
            Angle2 = 270 + Degree(ATan((X - AppMain::NewObject\StartX)/(AppMain::NewObject\StartY-Y)))
          EndIf
          AppMain::NewObject\EndAngle = Angle2
          AddPathCircle(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\OuterRadius , AppMain::NewObject\StartAngle,Angle2)
            
        Case 4
            
          DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
          AddPathCircle(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\OuterRadius , AppMain::NewObject\StartAngle,AppMain::NewObject\EndAngle) 
      
      EndSelect 

      VectorSourceColor(AppMain::NewObject\Colour)
      If  AppMain::NewObject\Filled = #True
        FillPath()
      Else
        StrokePath(AppMain::NewObject\Thickness * 5)
      EndIf   
      StopVectorDrawing()

    EndIf
    
  EndProcedure
  
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

  EndProcedure 
 
  Procedure DrawArc()
 
    Done = #False

    Repeat
  
      Event = WaitWindowEvent()
      Used = #False
      
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
              
            Case AppMain::drgCanvas
              Used = #True
              ;Snap To grid
              X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
              Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
              If X < 0
                X = 0
              ElseIf X > 640
                X = 640
              EndIf
              If Y < 0
                Y = 0
              ElseIf Y > 640
                Y = 640
              EndIf
          
              Select EventType()
          
                Case #PB_EventType_LeftClick
                  
                  Select Drawaction
                      
                    Case 0  ;Start Point

                      Process(x,y)
                      
                    Case 1 ;Radius
                      
                      AppMain::NewObject\StartX = X
                      AppMain::NewObject\StartY = Y
                      SetGadgetText(Main::strStartX,Str(AppMain::NewObject\StartX))      
                      SetGadgetText(Main::strStartY,Str(AppMain::NewObject\StartY))                        
                      Process(x,y)
                      
                    Case 2
                      Process(x,y)
                   
                    Case 3
                      Process(x,y)
                      Appmain::Drawmode = "Idle"                    
                      HideGadget(AppMain::cntSubAddEdit,#True)
                      Main::SaveElement("Arc")
                      Done = #True
                      Drawaction = Drawaction + 1
                      Process(x,y)
        
                  EndSelect
                  
                  Drawaction = Drawaction + 1
                  
                Case #PB_EventType_MouseMove
              
                     Select Drawaction
                    Case 0
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      SetGadgetText(Main::strRadius,Str(AppMain::NewObject\OuterRadius))      
                      Process(x,y)  
                    Case 2
                      SetGadgetText(Main::spnAngle1,Str(AppMain::NewObject\StartAngle))   
                      Process(x,y)                     
                    Case 3
                      SetGadgetText(Main::spnAngle2,Str(AppMain::NewObject\EndAngle))   
                      Process(x,y) 
                    ;Case 4
                    ;  Process(x,y)
                  EndSelect  
              
              EndSelect ;EventType()   
              
          EndSelect
      
      EndSelect
        
    Until Done = #True 

  EndProcedure
 
  Procedure NewArc()

  Define dlgArcProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThick.i,btnOk,btnCancel.i,Quit.i
  
  Define Colour.i,SelectedColour.i
  
  Define Cancel.i = #False
  
  dlgArcProperties = OpenWindow(#PB_Any, 0, 0, 150, 180, "Arc Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 55, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 85, 60, 20, "Thickness", #PB_Text_Right)   
  spnThickness = SpinGadget(#PB_Any, 85, 80, 50, 20, 0, 360, #PB_Spin_Numeric)     
  
  optFill = OptionGadget(#PB_Any, 10, 110, 40, 20, "Fill")
  optOutLine = OptionGadget(#PB_Any, 80, 110, 70, 20, "Outline")       
  btnOk = ButtonGadget(#PB_Any, 20, 140, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 140, 50, 30, "Cancel")
  
  StickyWindow(dlgArcProperties, #True) 
    
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  SetGadgetState(optOutLine, 1)
  SetGadgetText(spnThickness,"1")
  
  Repeat
  
    Event = WaitWindowEvent()
    Select Event 
      Case #PB_Event_Gadget
        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case btnOk
              
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThickness))          
             If GetGadgetState(optFill) = #True
               AppMain::NewObject\Filled = #True
             Else
               AppMain::NewObject\Filled = #False
             EndIf
            AppMain::NewObject\Thickness = GetGadgetState(spnThickness)
            AppMain::NewObject\Colour =  SelectedColour
            Quit = #True
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgArcProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawArc()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
EndIf  
    
    
  EndProcedure
    
  Procedure AddElements()   
  
    Define Done.i, Used.i, Height.i
    
    If Appmain::Drawmode = "Add"
      Height = 270
    Else
      Height = 295
    EndIf
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")   
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)

    
      TextGadget(#PB_Any, 5, 70, 60, 20, "Thickness", #PB_Text_Right)   
      Main::spnThickness = SpinGadget(#PB_Any, 85, 70, 50, 20, 0, 360, #PB_Spin_Numeric)     
      TextGadget(#PB_Any, 60, 95, 20, 20, "X", #PB_Text_Center)    
      TextGadget(#PB_Any, 100, 95, 20, 20, "Y", #PB_Text_Center)   
      TextGadget(#PB_Any, 15, 115, 35, 20, "Start", #PB_Text_Right)
      Main::strStartX = StringGadget(#PB_Any, 55, 110, 35, 20, "")
      Main::strStartY = StringGadget(#PB_Any, 95, 110, 35, 20, "")
      TextGadget(#PB_Any, 15, 140, 35, 20, "Radius", #PB_Text_Right)
      Main::strRadius = StringGadget(#PB_Any, 55, 140, 30, 20, "")
      Main::optFill = OptionGadget(#PB_Any, 10, 165, 40, 20, "Fill")
      Main::optOutLine = OptionGadget(#PB_Any, 80, 165, 70, 20, "Outline")       
      TextGadget(#PB_Any, 10, 200, 40, 20, "Angle 1", #PB_Text_Right)   
      Main::spnAngle1 = SpinGadget(#PB_Any, 55,195, 50, 20, 0, 360, #PB_Spin_Numeric)   
      TextGadget(#PB_Any, 10, 230, 40, 20, "Angle 2", #PB_Text_Right)      
      Main::spnAngle2 = SpinGadget(#PB_Any, 55, 225, 50, 20, 0, 360, #PB_Spin_Numeric)  
      If Appmain::Drawmode = "Add"
        SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(128,255,128))
        SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(128,255,128))                
      Else
        Main::btnRedraw = ButtonGadget(#PB_Any, 30, 255, 50, 25, "Redraw")     
        Main::btnDelete = ButtonGadget(#PB_Any, 90, 255, 50, 25, "Delete")     
      EndIf     
      CloseGadgetList() 
   
    If AppMain::Drawmode = "Add"     
      SetGadgetText(Main::spnThickness,"1")
      SetGadgetText(Main::strStartX,"")
      SetGadgetText(Main::strStartY,"")
      SetGadgetText(Main::strRadius, "")
    Else
      ;Set Edit Values
      SetGadgetText(Main::spnThickness,Str(Main::Elements(Main::CurrentElement)\Thickness))
      SetGadgetText(Main::strStartX, Str(Main::Elements(Main::CurrentElement)\StartX))
      SetGadgetText(Main::strStartY, Str(Main::Elements(Main::CurrentElement)\StartY))
      SetGadgetText(Main::strRadius, Str(Main::Elements(Main::CurrentElement)\OuterRadius))
      SetGadgetText(Main::spnAngle1, Str(Main::Elements(Main::CurrentElement)\StartAngle))       
      SetGadgetText(Main::spnAngle2, Str(Main::Elements(Main::CurrentElement)\EndAngle))       
      If Main::Elements(Main::CurrentElement)\Filled = #True
        SetGadgetState(Main::optFill, #True) 
      Else
        SetGadgetState(Main::optOutLine, #True)       
      EndIf
      
    EndIf
    
 

  EndProcedure   
  
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 335
; FirstLine = 87
; Folding = G+
; EnableXP
; EnableUnicode