﻿;{ ==Code Header Comment==============================
;        Name/title: DrawBox.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 01\11\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  7.0
;  Compiler version: PureBasic 5.5(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of boxes on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawBox
  
  Declare NewbOX()
  Declare AddElements()
  
EndDeclareModule

Module DrawBox

  Global Window_0

  Global spnSize, btnColour
    
  Global Thickness.i,Transparency.i,Filled.i
    
  Global DrawAction.i = -1    
    
  Procedure Process(x.i,y.i)

  If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
    
    ;Clearcanvas
    DrawVectorImage(ImageID(AppMain::DrawnImg), 255)    
    
    VectorSourceColor(AppMain::NewObject\Colour)

    Select DrawAction
            
      Case 0
            
        AppMain::NewObject\StartX = X
        AppMain::NewObject\StartY = Y
            
      Case 1

        AddPathBox(AppMain::NewObject\StartX,AppMain::NewObject\StartY, X - AppMain::NewObject\StartX , Y - AppMain::NewObject\StartY)
        AppMain::NewObject\EndX = X
        AppMain::NewObject\EndY = Y
            
    EndSelect

    If  AppMain::NewObject\Filled = #True
      FillPath()
    Else
      StrokePath(AppMain::NewObject\Thickness * 5)
    EndIf    

    StopVectorDrawing()

  EndIf
    
  EndProcedure
  
  Procedure DrawBox()
    
    Done = #False

    Repeat
  
      Event = WaitWindowEvent()
      Used = #False
      
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
              
            Case AppMain::drgCanvas
              Used = #True
              ;Snap To grid
              X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
              Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
              If X < 0
                X = 0
              ElseIf X > 640
                X = 640
              EndIf
              If Y < 0
                Y = 0
              ElseIf Y > 640
                Y = 640
              EndIf
          
              Select EventType()
          
                Case #PB_EventType_LeftClick
                  
                  If Drawaction < 1
                    Process(x,y)
                    SetGadgetText(Main::strStartX,Str(AppMain::NewObject\StartX))      
                    SetGadgetText(Main::strStartY,Str(AppMain::NewObject\StartY))              
                  Else
                    Appmain::Drawmode = "Idle"                    
                    HideGadget(AppMain::cntSubAddEdit,#True)
                    Main::SaveElement("Box")
                    Done = #True 
                  EndIf
                  Drawaction = Drawaction + 1
              
                Case #PB_EventType_MouseMove
              
                  Select Drawaction
                    Case 0
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      SetGadgetText(Main::strEndX,Str(X))      
                      SetGadgetText(Main::strEndY,Str(Y))  
                      Process(x,y)                     
                  EndSelect
              
              EndSelect ;EventType()   
              
          EndSelect ;EventGadget()
      
      EndSelect ;Event
        
    Until Done = #True
    
  EndProcedure
  
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

  EndProcedure 
  
  Procedure NewBox()
    
    Define dlgBoxProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThick.i,btnOk.i,btnCancel.i,Quit.i
  
    Define Colour.i,SelectedColour.i
  
    Define Cancel.i = #False
  
    dlgBoxProperties = OpenWindow(#PB_Any, 0, 0, 150, 180, "Box Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 55, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 85, 60, 20, "Thickness", #PB_Text_Right)   
  spnThickness = SpinGadget(#PB_Any, 85, 80, 50, 20, 0, 360, #PB_Spin_Numeric)     
  
  optFill = OptionGadget(#PB_Any, 10, 110, 40, 20, "Fill")
  optOutLine = OptionGadget(#PB_Any, 80, 110, 70, 20, "Outline")       
  btnOk = ButtonGadget(#PB_Any, 20, 140, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 140, 50, 30, "Cancel")
  
  StickyWindow(dlgBoxProperties, #True) 
  
  
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  SetGadgetState(optOutLine, 1)
  SetGadgetText(spnThickness,"1")
  
  Repeat
  
    Event = WaitWindowEvent()
    Select Event 
      Case #PB_Event_Gadget
        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case btnOk
              
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             ;SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThickness))          
             If GetGadgetState(optFill) = #True
               AppMain::NewObject\Filled = #True
             Else
               AppMain::NewObject\Filled = #False
             EndIf
            AppMain::NewObject\Thickness = GetGadgetState(spnThickness)
            AppMain::NewObject\Colour =  SelectedColour
            Quit = #True
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgBoxProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawBox()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
EndIf

    
  EndProcedure
  
  Procedure AddElements()
    
    
    Define Done.i, Used.i, Height.i
    
    If Appmain::Drawmode = "Add"
      Height = 200
    Else
      Height = 225
    EndIf
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
    TextGadget(#PB_Any, 5, 70, 60, 20, "Thickness", #PB_Text_Right)   
    Main::spnThickness = SpinGadget(#PB_Any, 85, 70, 50, 20, 0, 360, #PB_Spin_Numeric)       
    TextGadget(#PB_Any, 60, 95, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 95, 20, 20, "Y", #PB_Text_Center)   
    TextGadget(#PB_Any, 15, 115, 35, 20, "Start", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 110, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 110, 35, 20, "")
    TextGadget(#PB_Any, 15, 145, 35, 20, "End", #PB_Text_Right)     
    Main::strEndX = StringGadget(#PB_Any, 55, 140, 35, 20, "")
    Main::strEndY = StringGadget(#PB_Any, 95, 140, 35, 20, "") 
    Main::optFill = OptionGadget(#PB_Any, 10, 170, 40, 20, "Fill")
    Main::optOutLine = OptionGadget(#PB_Any, 80, 170, 70, 20, "Outline")      
    If Appmain::Drawmode = "Add"
      SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(128,255,128))
      SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(128,255,128))                
    Else
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 190, 50, 25, "Redraw")     
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 190, 50, 25, "Delete")     
    EndIf   
      
    CloseGadgetList() 

  EndProcedure  
  
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 235
; FirstLine = 113
; Folding = H0
; EnableXP
; EnableUnicode