﻿;{ ==Code Header Comment==============================
;        Name/title: DrawCurve.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of curves on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawCurve
  
  Declare NewCurve()
  Declare AddElements()
  
EndDeclareModule

Module DrawCurve

  Global Window_0

  Global strStartX, strStartY, strMidX1, strMidY1, strMidX2, strMidY2, strEndX, strEndY, btnColour
    
  Global Thickness.i,  Transparency.i
  
  Global DrawAction.i = -1   
  
  Procedure Process(x.i,y.i)

  If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
    
    ;Clearcanvas
    DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
     
        Select DrawAction
            
          Case 0
            AppMain::NewObject\StartX = X
            AppMain::NewObject\StartY = Y
          Case 1
            AppMain::NewObject\EndX = X
            AppMain::NewObject\EndY = Y
            MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
            AddPathCurve(AppMain::NewObject\StartX, AppMain::NewObject\StartY,AppMain::NewObject\StartX, AppMain::NewObject\StartY, AppMain::NewObject\EndX, AppMain::NewObject\EndY)  

          Case 2
            AppMain::NewObject\MidX1 = X
            AppMain::NewObject\MidY1 = Y
            MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
            AddPathCurve(AppMain::NewObject\MidX1, AppMain::NewObject\MidY1,AppMain::NewObject\StartX, AppMain::NewObject\StartY, AppMain::NewObject\EndX, AppMain::NewObject\EndY)  
             
          Case 3
            AppMain::NewObject\MidX2 = X
            AppMain::NewObject\MidY2 = Y
            MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
            AddPathCurve(AppMain::NewObject\MidX1, AppMain::NewObject\MidY1,AppMain::NewObject\MidX2, AppMain::NewObject\MidY2, AppMain::NewObject\EndX, AppMain::NewObject\EndY)  
        EndSelect

    VectorSourceColor(AppMain::NewObject\Colour)
    StrokePath(AppMain::NewObject\Thickness * 5 )
    StopVectorDrawing()

  EndIf
    
  EndProcedure
  
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

  EndProcedure 
  
  Procedure DrawCurve()
    
    Done = #False

    Repeat
  
      Event = WaitWindowEvent()
      Used = #False
      
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
              
            Case AppMain::drgCanvas
              Used = #True
              ;Snap To grid
              X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
              Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
              If X < 0
                X = 0
              ElseIf X > 640
                X = 640
              EndIf
              If Y < 0
                Y = 0
              ElseIf Y > 640
                Y = 640
              EndIf
          
              Select EventType()
          
                Case #PB_EventType_LeftClick
                  
                  If Drawaction < 4
                    Process(x,y)
                    Drawaction = Drawaction + 1 
                  EndIf
                  If Drawaction = 4
                    Main::SaveElement("Curve")
                  EndIf
              
                Case #PB_EventType_MouseMove
              
                  Select Drawaction
                    Case 0
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      SetGadgetText(Main::strEndX,Str(X))      
                      SetGadgetText(Main::strEndY,Str(Y))  
                      Process(x,y)   
                    Case 2 
                      SetGadgetText(Main::strMidX1,Str(X))      
                      SetGadgetText(Main::strMidY1,Str(Y))  
                      Process(x,y)              
                    Case 3 
                      SetGadgetText(Main::strMidX2,Str(X))      
                      SetGadgetText(Main::strMidY2,Str(Y))  
                      Process(x,y) 
 
                    Case 4
                      Appmain::Drawmode = "Idle"                    
                      HideGadget(AppMain::cntSubAddEdit,#True)
                      Main::SaveElement("Curve")
                      Done = #True                     
                  EndSelect 
              
              EndSelect ;EventType()   
              
          EndSelect
      
      EndSelect
        
    Until Done = #True 
    
    
  EndProcedure
  
  Procedure NewCurve()
    
    Define dlgCurveProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThick.i,btnOk.i,btnCancel.i,Quit.i
  
    Define Colour.i,SelectedColour.i
  
    Define Cancel.i = #False
  
  dlgCurveProperties = OpenWindow(#PB_Any, 0, 0, 150, 180, "Arc Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 55, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 85, 60, 20, "Thickness", #PB_Text_Right)   
  spnThick = SpinGadget(#PB_Any, 85, 80, 50, 20, 0, 360, #PB_Spin_Numeric)     
  
  ;optFill = OptionGadget(#PB_Any, 10, 110, 40, 20, "Fill")
  ;optOutLine = OptionGadget(#PB_Any, 80, 110, 70, 20, "Outline")       
  btnOk = ButtonGadget(#PB_Any, 20, 140, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 140, 50, 30, "Cancel")
  
  StickyWindow(dlgCurveProperties, #True) 
    
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  ;SetGadgetState(optOutLine, 1)
  SetGadgetText(spnThick,"1")
  
  Repeat
  
    Event = WaitWindowEvent()
    Select Event 
      Case #PB_Event_Gadget
        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case btnOk
              
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThick))          
             ;If GetGadgetState(optFill) = #True
             ;  AppMain::NewObject\Filled = #True
             ;Else
             ;  AppMain::NewObject\Filled = #False
             ;EndIf
            AppMain::NewObject\Thickness = GetGadgetState(spnThick)
            AppMain::NewObject\Colour =  SelectedColour
            Quit = #True
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgCurveProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawCurve()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
EndIf  
    
     
    
  EndProcedure
  
  Procedure AddElements()
    
    Define Done.i, Used.i, Height.i
    
    If Appmain::Drawmode = "Add"
      Height = 220
    Else
      Height = 260
    EndIf   
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")   
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 75, 60, 20, "Thickness", #PB_Text_Right)   
    Main::spnThickness = SpinGadget(#PB_Any, 90, 70, 50, 20, 0, 360, #PB_Spin_Numeric)     
    TextGadget(#PB_Any, 60, 100, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 100, 20, 20, "Y", #PB_Text_Center)   
    TextGadget(#PB_Any, 15, 125, 35, 20, "Start", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 120, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 120, 35, 20, "")
    TextGadget(#PB_Any, 15, 150, 30, 20, "End", #PB_Text_Right)
    Main::strEndX = StringGadget(#PB_Any, 55, 145, 35, 20, "")
    Main::strEndY = StringGadget(#PB_Any, 95, 145, 35, 20, "")      
    TextGadget(#PB_Any, 15, 175, 30, 20, "Pull 1", #PB_Text_Right)
    Main::strMidX1 = StringGadget(#PB_Any, 55, 170, 35, 20, "")
    Main::strMidY1 = StringGadget(#PB_Any, 95, 170, 35, 20, "")    
    TextGadget(#PB_Any, 15, 200, 30, 20, "Pull 2", #PB_Text_Right)
    Main::strMidX2 = StringGadget(#PB_Any, 55, 195, 35, 20, "")
    Main::strMidY2 = StringGadget(#PB_Any, 95, 195, 35, 20, "")    
   
    If Appmain::Drawmode = "Add"
      SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(128,255,128))
      SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(128,255,128))                
    Else
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 225, 50, 25, "Redraw")     
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 225, 50, 25, "Delete")     
    EndIf     
      
    CloseGadgetList() 
    
   
 ;   If App::Drawmode = "Add"     
 ;     SetGadgetText(spnThickness,"1")
 ;     SetGadgetText(strStartX,"")
 ;     SetGadgetText(strStartY,"")
 ;     ;SetGadgetText(strEndX, "")
 ;     ;SetGadgetText(strEndY, "")      
 ;   Else
 ;     ;Set Edit Values
 ;     SetGadgetText(spnThickness,Str(Main::Elements(Main::CurrentElement)\Thickness))
 ;     SetGadgetText(strStartX, Str(Main::Elements(Main::CurrentElement)\StartX))
 ;     SetGadgetText(strStartY, Str(Main::Elements(Main::CurrentElement)\StartY))
 ;     SetGadgetText(strMidX1, Str(Main::Elements(Main::CurrentElement)\MidX1))
 ;     SetGadgetText(strMidY1, Str(Main::Elements(Main::CurrentElement)\MidY1))     
 ;     SetGadgetText(strMidX2, Str(Main::Elements(Main::CurrentElement)\MidX2))
 ;     SetGadgetText(strMidY2, Str(Main::Elements(Main::CurrentElement)\MidY2))    
 ;     SetGadgetText(strEndX, Str(Main::Elements(Main::CurrentElement)\EndX))
 ;     SetGadgetText(strEndY, Str(Main::Elements(Main::CurrentElement)\EndY))
 ;   EndIf
    
 

  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 161
; FirstLine = 102
; Folding = n9
; EnableXP
; EnableUnicode