﻿;{ ==Code Header Comment==============================
;        Name/title: DrawEllipse.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of ellipses on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}
DeclareModule DrawEllipse
  
  Declare NewEllipse()
  Declare AddElements()
  
EndDeclareModule

Module DrawEllipse

  Global strStartX.i, strStartY.i, strXRadius.i, strYRadius.i, spnAngle1.i, spnAngle2.i, btnDone.i

    
  Global Thickness.i, Filled.i
    
  Global DrawAction.i = -1    
    
  Procedure Process(x.i,y.i)

  If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
    
    ;Clearcanvas
    DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
    
    VectorSourceColor(AppMain::NewObject\Colour)
    
        Select DrawAction
            
          Case 0
            ;Centre Point
            AppMain::NewObject\StartX = X
            AppMain::NewObject\StartY = Y
            
          Case 1
            If X < AppMain::NewObject\StartX
              Swap X , AppMain::NewObject\StartX
              AppMain::NewObject\InnerRadius = X - AppMain::NewObject\StartX 
              Swap X , AppMain::NewObject\StartX
            Else
              AppMain::NewObject\InnerRadius =X - AppMain::NewObject\StartX            
            EndIf
            If AppMain::NewObject\StartX < 10
              AppMain::NewObject\StartX = 10
            EndIf
            
            If Y < AppMain::NewObject\StartY
              Swap Y , AppMain::NewObject\StartY
              AppMain::NewObject\OuterRadius = Y - AppMain::NewObject\StartY 
              Swap Y , AppMain::NewObject\StartY
            Else
               AppMain::NewObject\OuterRadius = Y - AppMain::NewObject\StartY            
            EndIf           
            If AppMain::NewObject\StartY < 10
              AppMain::NewObject\StartY = 10
            EndIf

            AddPathEllipse(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\InnerRadius,AppMain::NewObject\OuterRadius)
            SetGadgetText(Main::strXRadius,Str(AppMain::NewObject\InnerRadius))            
            SetGadgetText(Main::strYRadius,Str(AppMain::NewObject\OuterRadius))    
            
        EndSelect

        VectorSourceColor(AppMain::NewObject\Colour)
        If  AppMain::NewObject\Filled = #True
          FillPath()
        Else
          StrokePath(AppMain::NewObject\Thickness * 5)
        EndIf    

    StopVectorDrawing()

  EndIf
    
  EndProcedure
  
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

  EndProcedure
  
  Procedure DrawEllipse()
        
    Done = #False

    Repeat
  
      Event = WaitWindowEvent()
      Used = #False
      
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
              
            Case AppMain::drgCanvas
              Used = #True
              ;Snap To grid
              X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
              Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
              If X < 0
                X = 0
              ElseIf X > 640
                X = 640
              EndIf
              If Y < 0
                Y = 0
              ElseIf Y > 640
                Y = 640
              EndIf
          
              Select EventType()
          
                Case #PB_EventType_LeftClick
                  
                  If Drawaction < 1
                    Process(x,y)
                    SetGadgetText(Main::strStartX,Str(AppMain::NewObject\StartX))      
                    SetGadgetText(Main::strStartY,Str(AppMain::NewObject\StartY))              
                  Else
                    Appmain::Drawmode = "Idle"                    
                    HideGadget(AppMain::cntSubAddEdit,#True)
                    Main::SaveElement("Ellipse")
                    Done = #True                  
                  EndIf
                  Drawaction = Drawaction + 1
              
                Case #PB_EventType_MouseMove
              
                  Select Drawaction
                    Case 0
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      Process(x,y)                     
                  EndSelect
              
              EndSelect ;EventType()   
              
          EndSelect
      
      EndSelect
         
    Until Done = #True 
    
  EndProcedure
  
  Procedure NewEllipse()
       
  Define dlgEllipseProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThickness.i,btnCancel.i,Quit.i
  
  Define Colour.i,SelectedColour.i
  
  Define Cancel.i = #False
  
  dlgEllipseProperties = OpenWindow(#PB_Any, 0, 0, 145, 180, "Ellipse Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 55, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 85, 60, 20, "Thickness", #PB_Text_Right)   
  spnThickness = SpinGadget(#PB_Any, 80, 80, 50, 20, 1, 128, #PB_Spin_Numeric) 
      
  optFill = OptionGadget(#PB_Any, 10, 110, 40, 20, "Fill")
  optOutLine = OptionGadget(#PB_Any, 80, 110, 70, 20, "Outline")
       
  btnOk = ButtonGadget(#PB_Any, 20, 140, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 140, 50, 30, "Cancel")
  
  StickyWindow(dlgEllipseProperties, #True)  
  
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  SetGadgetState(optOutLine, 1)
  SetGadgetText(spnThickness,"1")
  
    Repeat
  
    LineEvent = WaitWindowEvent()
    Select LineEvent 
      Case #PB_Event_Gadget
        ;Debug "Gadget"
        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case btnOk
            
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             ;SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThickness))
             If GetGadgetState(optFill) = #True
               AppMain::NewObject\Filled = #True
             Else
               AppMain::NewObject\Filled = #False
             EndIf          
            AppMain::NewObject\Thickness = GetGadgetState(spnThickness)
            AppMain::NewObject\Colour =  SelectedColour
            Quit = #True
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgEllipseProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawEllipse()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
  EndIf
    
    
  EndProcedure
     
  Procedure AddElements()
    
    Define Done.i, Used.i
    
    If Appmain::Drawmode = "Add"
      Height = 235
    Else
      Height = 260
    EndIf
    Define StartY.i
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
    TextGadget(#PB_Any, 5, 70, 60, 20, "Thickness", #PB_Text_Right)   
    Main::spnThickness = SpinGadget(#PB_Any, 85, 70, 50, 20, 0, 360, #PB_Spin_Numeric) 
    
    TextGadget(#PB_Any, 60, 95, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 95, 20, 20, "Y", #PB_Text_Center)   
    TextGadget(#PB_Any, 15, 115, 35, 20, "Centre", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 110, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 110, 35, 20, "")
    TextGadget(#PB_Any, 15, 140, 45, 20, "X Radius", #PB_Text_Right)
    Main::strXRadius = StringGadget(#PB_Any, 95, 140, 35, 20, "")
    TextGadget(#PB_Any, 15, 170, 45, 20, "Y Radius", #PB_Text_Right)     
    Main::strYRadius = StringGadget(#PB_Any, 95, 170, 35, 20, "")      
    Main::optFill = OptionGadget(#PB_Any, 10, 195, 40, 20, "Fill")
    Main::optOutLine = OptionGadget(#PB_Any, 80, 195, 70, 20, "Outline")       
 
    If Appmain::Drawmode <> "Add"
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 225, 50, 25, "Redraw")     
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 225, 50, 25, "Delete")   
    EndIf       
    CloseGadgetList()

    
    ;Set Defaults
    If AppMain::Drawmode = "Add"     
      SetGadgetText(Main::spnThickness,"1")
      SetGadgetText(Main::strStartX,"")
      SetGadgetText(Main::strStartY,"")
    EndIf     
 


  EndProcedure
  

  
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 298
; FirstLine = 163
; Folding = H-
; EnableXP
; EnableUnicode