﻿;{ ==Code Header Comment==============================
;        Name/title: DrawLine.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of lines on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawLine
  
  Declare NewLine()
  Declare AddElements()
  
EndDeclareModule

Module DrawLine
  
  Global Accept.i = #True
  
  Global strStartX.i, strStartY.i, strEndX.i, strEndY.i, spnThickness.i, btnDone.i
  
  Global DrawAction.i = -1
  
  Global TestRound.i = #True
  
Procedure Process(x.i,y.i)

    Select DrawAction
            
      Case 0
        ;No Action 
            
      Case 1
        
       If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
         ;Clearcanvas
         DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
         VectorSourceColor(AppMain::NewObject\Colour)     
         MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
         AddPathLine(X,Y)
         If AppMain::NewObject\Round
           StrokePath(AppMain::NewObject\Thickness * 5,#PB_Path_RoundEnd)
         Else
           StrokePath(AppMain::NewObject\Thickness * 5)
         EndIf
         
         StopVectorDrawing()   
       EndIf  
            
    EndSelect

  EndProcedure
  
Procedure DrawLine()
  
  Done = #False
  Static OldX.i,OldY.i
  
  Repeat
  
    Event = WaitWindowEvent()
    
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
              
          Case AppMain::drgCanvas
            ;Snap To grid
            X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
            Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
            If X < 0
              X = 0
            ElseIf X > 640
              X = 640
            EndIf
            If Y < 0
              Y = 0
            ElseIf Y > 640
              Y = 640
            EndIf
            
            Select EventType()
          
              Case #PB_EventType_LeftClick
     
                Select Drawaction
                  Case 0 
                    ;First Mouse Click Set Start Point
                    AppMain::NewObject\StartX = X
                    AppMain::NewObject\StartY = Y
                    SetGadgetText(Main::strStartX,Str(AppMain::NewObject\StartX))      
                    SetGadgetText(Main::strStartY,Str(AppMain::NewObject\StartY))                   
                    ;Change String highlights
                    SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
                    SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                
                    SetGadgetColor(Main::strEndX, #PB_Gadget_BackColor,RGB(128,255,128))
                    SetGadgetColor(Main::strEndY, #PB_Gadget_BackColor,RGB(128,255,128))
                    Drawaction = Drawaction + 1
              
                  Case 1
                    ;Second Click Set End Point
                    AppMain::NewObject\EndX = X
                    AppMain::NewObject\EndY = Y
                    Drawaction = Drawaction + 1
                    Appmain::Drawmode = "Idle"                    
                    HideGadget(AppMain::cntSubAddEdit,#True)
                    Main::SaveElement("Line")
                    Done = #True 
                EndSelect
                
              Case #PB_EventType_MouseMove
                
                ;Only on significant move
                If (x <> OldX) Or (y <> OldY) 
                  OldX = x
                  OldY = y
                  
                  Select Drawaction
                    Case 0
                      ;Show Start Point Dynamic
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      Process(x,y) 
                      SetGadgetText(Main::strEndX,Str(X))      
                      SetGadgetText(Main::strEndY,Str(Y))  

                  EndSelect ;Drawaction
                  
                EndIf
                
            EndSelect  ;EventType()   
            
        EndSelect  ;EventGadget()
        
    EndSelect  ;Event 
   
  Until Done = #True
  
  
EndProcedure
  
Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

EndProcedure

Procedure NewLine()
  
  Define dlgLineProperties.i,LineEvent.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThick.i,btnOk,btnCancel.i,Quit.i,chkRound.i
  
  Define Colour.i,SelectedColour.i
  
  Define Cancel.i = #False
  
  dlgLineProperties = OpenWindow(#PB_Any, 0, 0, 150, 170, "Line Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 50, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  TextGadget(#PB_Any, 10, 80, 70, 20, "Thickness", #PB_Text_Right)
  spnThick = SpinGadget(#PB_Any, 90, 80, 40, 20, 1, 128, #PB_Spin_ReadOnly | #PB_Spin_Numeric)
  chkRound = CheckBoxGadget(#PB_Any, 25, 110, 140, 20, "Round Ends") 
  btnOk = ButtonGadget(#PB_Any, 20, 135, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 135, 50, 30, "Cancel")
  
  StickyWindow(dlgLineProperties, #True) 
  
  
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  SetGadgetText(spnTransp,"255")  
  
  SetGadgetText(spnThick,"1")
  
  Repeat
  
    LineEvent = WaitWindowEvent()
    Select LineEvent 
      Case #PB_Event_Gadget
        
        Select EventGadget()
            
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case spnTransp
            
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case btnOk
            
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThick))
             SetGadgetState(Main::chkRound,GetGadgetState(chkRound))            
             
             If GetGadgetState(chkRound) = #True             
               AppMain::NewObject\Round = #True
             Else
               AppMain::NewObject\Round = #False
             EndIf
             
             AppMain::NewObject\Thickness = GetGadgetState(spnThick)
             AppMain::NewObject\Colour =  SelectedColour
             Quit = #True
             
           Case btnCancel
             
             Cancel = #True
             Quit = #True
            
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgLineProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawLine()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                
  SetGadgetColor(Main::strEndX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strEndY, #PB_Gadget_BackColor,RGB(255,255,255))
  AppMain::Drawmode = "Idle"
EndIf

EndProcedure

Procedure AddElements()
    
    Define Done.i, Used.i
    
    If Appmain::Drawmode = "Add"
      Height = 195
    Else
      Height = 220
    EndIf
    
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
    TextGadget(#PB_Any, 5, 75, 60, 20, "Thickness", #PB_Text_Right)   
    Main::spnThickness = SpinGadget(#PB_Any, 85, 70, 50, 20, 1, 25, #PB_Spin_Numeric)       
    TextGadget(#PB_Any, 60, 95, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 95, 20, 20, "Y", #PB_Text_Center)   
    TextGadget(#PB_Any, 10, 115, 35, 20, "Start", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 110, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 110, 35, 20, "")
    TextGadget(#PB_Any, 10,145, 35, 20, "End", #PB_Text_Right)
    Main::strEndX = StringGadget(#PB_Any, 55, 140, 35, 20, "")
    Main::strEndY = StringGadget(#PB_Any, 95, 140, 35, 20, "")      
    Main::chkRound = CheckBoxGadget(#PB_Any, 25, 165, 140, 20, "Round Ends") 
    If Appmain::Drawmode <> "Add"
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 190, 50, 25, "Redraw")     
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 190, 50, 25, "Delete")     
    EndIf
    CloseGadgetList() 

    SetGadgetState(Main::spnThickness,AppMain::NewObject\Thickness)
    
    If AppMain::Drawmode = "Add"
      ;Highlight StartX and StartY
      ;SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(128,255,128))
      ;SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(128,255,128))    
    EndIf
  
  EndProcedure

EndModule

; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 289
; FirstLine = 187
; Folding = P-
; EnableXP
; EnableUnicode