﻿;{ ==Code Header Comment==============================
;        Name/title: DrawPoly.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of polygons on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawPoly
  
 Declare NewPoly()
 Declare AddElements()
  
EndDeclareModule

Module DrawPoly

  Global strStartX, strStartY, OptFill, OptOutline, strAngle.i, btnOk, btnDone, chkRound
   
  Global DrawAction.i = -1 
    
  Procedure DrawShape()
 
    Define Rotate.d,trans.i,dColour.i
    NumberOfSides = AppMain::NewObject\Points
    RotateCoordinates(AppMain::NewObject\StartX, AppMain::NewObject\StartY, AppMain::NewObject\StartAngle)
    Rotate = 360/AppMain::NewObject\Points
    
    trans = Alpha(AppMain::NewObject\Colour)
    dColour = RGBA(Red(AppMain::NewObject\Colour),Green(AppMain::NewObject\Colour),Blue(AppMain::NewObject\Colour),255)
    BeginVectorLayer(trans)
    VectorSourceColor(dColour)
    MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY-AppMain::NewObject\OuterRadius)
    For k = 1 To NumberOfSides - 1
      RotateCoordinates(AppMain::NewObject\StartX, AppMain::NewObject\StartY, Rotate)
      AddPathLine(AppMain::NewObject\StartX, AppMain::NewObject\StartY-AppMain::NewObject\OuterRadius)
    Next
    ClosePath()  
    
    If  AppMain::NewObject\Filled = #True
      If AppMain::NewObject\Round  = #True
        FillPath(#PB_Path_Preserve)
        StrokePath(AppMain::NewObject\Thickness * 5, #PB_Path_RoundCorner) 
      Else
        FillPath()
      EndIf
    Else
      If AppMain::NewObject\Round  = #True
        StrokePath(AppMain::NewObject\Thickness * 5, #PB_Path_RoundCorner) 
      Else
      StrokePath(AppMain::NewObject\Thickness * 5)
      EndIf     

    EndIf 
EndVectorLayer()
 
  EndProcedure 
    
  Procedure Process(x.i,y.i)
    
    Static Angle1.i
    
    If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
      
      ;Clear canvas To Existing Drawing
      DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
       
      VectorSourceColor(AppMain::NewObject\Colour)
      
      Select DrawAction
          
        Case 0  ;Set Centre Point
          
          ;AppMain::NewObject\StartX = X
          ;AppMain::NewObject\StartY = Y
            
        Case 1 ;Set Outer Radius

          AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))
          DrawShape()
        
        Case 2
            
            ;Set rotation angle
            VectorSourceColor(RGBA($00,$FF,$00,$FF))
            AddPathCircle(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\OuterRadius , 0,360)     
            StrokePath(1)   
            
            ;Show Chose angle line           
            VectorSourceColor(RGBA($FF,$00,$00,$FF))
         
            MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
            AddPathLine(x,y)
            DashPath(1, 5)
            If x => AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
              If X - AppMain::NewObject\StartX = 0
                Angle1 = 90
              Else
                Angle1 = Degree(ATan((Y - AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
              EndIf
            ElseIf  x =< AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
              If Y-AppMain::NewObject\StartY = 0
                Angle1 = 180
              Else
                Angle1 = 90 + Degree(ATan((AppMain::NewObject\StartX-X)/(Y-AppMain::NewObject\StartY)))
              EndIf
            ElseIf  x =< AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY
              If X - AppMain::NewObject\StartX = 0
                Angle1 = 270
              Else
                Angle1 = 180 + Degree(ATan((Y-AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
              EndIf
            ElseIf  x => AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY  
              Angle1 = 270 + Degree(ATan((X - AppMain::NewObject\StartX)/(AppMain::NewObject\StartY-Y)))
            EndIf
            AppMain::NewObject\StartAngle = Angle1
            ;Reset Vector colour
            VectorSourceColor(AppMain::NewObject\Colour)
            Drawshape()
  
          Case  3
            Drawshape()
          
             
       EndSelect 

    VectorSourceColor(AppMain::NewObject\Colour)
    StrokePath(AppMain::NewObject\Thickness * 5)
    StopVectorDrawing()
    
  EndIf
    
  EndProcedure   
    
  Procedure DrawPoly()

  Done = #False
  Static OldX.i,OldY.i
  
  Repeat
  
    Event = WaitWindowEvent()
    
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
              
          Case AppMain::drgCanvas
            ;Snap To grid
            X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
            Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
            If X < 0
              X = 0
            ElseIf X > 640
              X = 640
            EndIf
            If Y < 0
              Y = 0
            ElseIf Y > 640
              Y = 640
            EndIf
            
            Select EventType()
          
              Case #PB_EventType_LeftClick

                Select Drawaction
                  Case 0 
                    ;First Mouse Click Set Centre Point
                    AppMain::NewObject\StartX = X
                    AppMain::NewObject\StartY = Y
                    SetGadgetText(Main::strStartX,Str(AppMain::NewObject\StartX))      
                    SetGadgetText(Main::strStartY,Str(AppMain::NewObject\StartY))                   
                    Drawaction = Drawaction + 1
              
                  Case 1
                    ;Second Click Set Radius
                    AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))           
                    Drawaction = Drawaction + 1
 
                  Case 2
                    ;Third Click Set Rotation
                    SetGadgetText(Main::strAngle,Str(AppMain::NewObject\StartAngle))   
                    Drawaction = Drawaction + 1 
                    Process(x,y) 
                    Appmain::Drawmode = "Idle"                    
                    HideGadget(AppMain::cntSubAddEdit,#True)
                    Main::SaveElement("Poly")
                    Done = #True
                    
                    Drawaction = Drawaction + 1             
                EndSelect
                
              Case #PB_EventType_MouseMove
                
                ;Only on significant move
                If (x <> OldX) Or (y <> OldY) 
                  OldX = x
                  OldY = y
                  
                  Select Drawaction
                    Case 0
                      ;Show Centre Point Dynamic
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      ;Show Radius Dynamic
                      AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))           
                      Process(x,y) 
                      SetGadgetText(Main::strRadius,Str(AppMain::NewObject\OuterRadius))
                   Case 2 
                     ;Third Show Rotation Angle
                     AppMain::NewObject\StartAngle = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))           
                     Process(x,y) 
                     SetGadgetText(Main::strAngle,Str(AppMain::NewObject\StartAngle))

                  EndSelect ;Drawaction
                  
                EndIf
                
            EndSelect  ;EventType()   
            
        EndSelect  ;EventGadget()
        
    EndSelect  ;Event 
   
  Until Done = #True  

  EndProcedure
  
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

EndProcedure

Procedure NewPoly()

  Define dlgPolyProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThickness.i,btnCancel.i,Quit.i
  
  Define Colour.i,SelectedColour.i
  
  Define Cancel.i = #False
  
  dlgPolyProperties = OpenWindow(#PB_Any, 0, 0, 145, 230, "Polygon Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 55, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 85, 60, 20, "Thickness", #PB_Text_Right)   
  spnThickness = SpinGadget(#PB_Any, 80, 80, 50, 20, 1, 128, #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 115,50, 20, "Sides", #PB_Text_Right)   
  spnSides = SpinGadget(#PB_Any, 80, 110, 50, 20, 3, 10, #PB_Spin_Numeric)    
      
  optFill = OptionGadget(#PB_Any, 10, 140, 40, 20, "Fill")
  optOutLine = OptionGadget(#PB_Any, 80, 140, 70, 20, "Outline")
  
  chkRound = CheckBoxGadget(#PB_Any, 25, 165, 140, 20, "Round Corners") 
  
  btnOk = ButtonGadget(#PB_Any, 20, 195, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 195, 50, 30, "Cancel")
  
  StickyWindow(dlgPolyProperties, #True)  
  
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  SetGadgetState(optOutLine, 1)
  SetGadgetText(spnThickness,"1")
  SetGadgetText(spnSides,"3")
  
    Repeat
  
    LineEvent = WaitWindowEvent()
    Select LineEvent 
      Case #PB_Event_Gadget

        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case btnOk
            
            StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
              VectorSourceColor(SelectedColour)
              AddPathBox(0,0,25,25) 
              FillPath()
            StopVectorDrawing()         
            SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
            SetGadgetState(Main::spnThickness,GetGadgetState(spnThickness))
            If GetGadgetState(optFill) = #True
              AppMain::NewObject\Filled = #True
              SetGadgetState(Main::optFill,#True)   
            Else
              AppMain::NewObject\Filled = #False
              SetGadgetState(Main::optOutLine,#True)              
            EndIf
            
            AppMain::NewObject\Points = GetGadgetState(spnSides)
            AppMain::NewObject\Thickness = GetGadgetState(spnThickness)
            AppMain::NewObject\Colour =  SelectedColour
            SetGadgetState(Main::chkRound,GetGadgetState(chkRound))            
            If GetGadgetState(chkRound) = #True             
              AppMain::NewObject\Round = #True
            Else
              AppMain::NewObject\Round = #False
            EndIf           
            Quit = #True
            
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgPolyProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawPoly()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
  EndIf
EndProcedure


  
  Procedure AddElements()
    
    Define Done.i, Used.i
    
    If Appmain::Drawmode = "Add"
      Height = 285
    Else
      Height = 305
    EndIf
    Define StartY.i
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
    
    TextGadget(#PB_Any, 5, 70,50, 20, "Sides", #PB_Text_Right)   
    Main::spnSides = SpinGadget(#PB_Any, 80, 70, 50, 20, 3, 10, #PB_Spin_Numeric)    
    TextGadget(#PB_Any, 5, 105, 60, 20, "Thickness", #PB_Text_Right)   
    Main::spnThickness = SpinGadget(#PB_Any, 80, 100, 50, 20, 1, 128, #PB_Spin_Numeric)       
    Main::optFill = OptionGadget(#PB_Any, 10, 125, 40, 20, "Fill")
    Main::optOutLine = OptionGadget(#PB_Any, 80, 125, 70, 20, "Outline")
    TextGadget(#PB_Any, 60, 155, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 155, 20, 20, "Y", #PB_Text_Center)    
    TextGadget(#PB_Any, 15, 180, 35, 20, "Centre", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 175, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 175, 35, 20, "")       
    TextGadget(#PB_Any, 15, 205, 35, 20, "Radius", #PB_Text_Right)
    Main::strRadius = StringGadget(#PB_Any, 55, 200, 30, 20, "")
    TextGadget(#PB_Any, 5, 225, 45, 20, "Rotation", #PB_Text_Right)
    Main::strAngle = StringGadget(#PB_Any, 55, 225, 30, 20, "")
    Main::chkRound = CheckBoxGadget(#PB_Any, 25, 250, 140, 20, "Round Corners") 
    If Appmain::Drawmode <> "Add"
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 275, 50, 25, "Redraw")      
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 275, 50, 25, "Delete")     
    EndIf   
      
    CloseGadgetList() 
    
    ;Set Defaults
    If AppMain::Drawmode = "Add"     
      SetGadgetText(Main::spnThickness,"1")
      SetGadgetText(Main::spnSides,"3")      
      SetGadgetText(Main::strStartX,"")
      SetGadgetText(Main::strStartY,"")
      SetGadgetText(Main::strRadius, "")
      SetGadgetText(Main::strAngle, "")      
   
    EndIf

  EndProcedure   
  

      
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 47
; FirstLine = 37
; Folding = f7
; EnableXP
; EnableUnicode