﻿;{ ==Code Header Comment==============================
;        Name/title: DrawStar.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of stars on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawStar
  
  Declare NewStar()
  Declare AddElements()
  
EndDeclareModule

Module DrawStar

  Global strStartX, strStartY, OptFill, OptOutline, btnOk, btnDone
   
  Global DrawAction.i = -1 
    
  Procedure DrawShape()
      
    Define Rotate.d
    Define k.i
    
    Rotate = 360/(AppMain::NewObject\Points * 2)
    
    MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY - AppMain::NewObject\OuterRadius)
    For k = 1 To AppMain::NewObject\Points * 2
      RotateCoordinates(AppMain::NewObject\StartX, AppMain::NewObject\StartY, Rotate)
        If k & 1 = 1
          AddPathLine(AppMain::NewObject\StartX, AppMain::NewObject\StartY - AppMain::NewObject\InnerRadius)
       Else
          AddPathLine(AppMain::NewObject\StartX, AppMain::NewObject\StartY - AppMain::NewObject\OuterRadius)
       EndIf
    Next
    ClosePath()  

    If  AppMain::NewObject\Filled = #True
      FillPath()
    Else
      StrokePath(AppMain::NewObject\Thickness * 5)
    EndIf 
 
   EndProcedure  

  Procedure Process(x.i,y.i)
    
    Static CentreX.i,CentreY.i,Radius.i,Angle1.i,Angle2.i 
    
    If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
    
      ;Clear canvas To Existing Drawing
      DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
    
      VectorSourceColor(AppMain::NewObject\Colour)
 
      Select DrawAction
        
        Case 0  ;Set Centre Point
        
          AppMain::NewObject\StartX = X
          AppMain::NewObject\StartY = Y
            
        Case 1 ;Set Outer Radius

          AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))
          AppMain::NewObject\InnerRadius = AppMain::NewObject\OuterRadius - 20
          DrawShape()
        
        Case 2 ;Set Inner Radius

          AppMain::NewObject\InnerRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))
          DrawShape()
         
          
      EndSelect 

    VectorSourceColor(AppMain::NewObject\Colour)
    StrokePath(AppMain::NewObject\Thickness * 5)
    StopVectorDrawing()

  EndIf
    
  EndProcedure
  
  Procedure DrawStar()
      
    Done = #False

    Repeat
  
      Event = WaitWindowEvent()
      
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
              
            Case AppMain::drgCanvas

              ;Snap To grid
              X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
              Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
              If X < 0
                X = 0
              ElseIf X > 640
                X = 640
              EndIf
              If Y < 0
                Y = 0
              ElseIf Y > 640
                Y = 640
              EndIf
          
              Select EventType()
          
                Case #PB_EventType_LeftClick
                  
                  If Drawaction < 2
                    Process(x,y)
                  Else
                    Appmain::Drawmode = "Idle"                    
                    HideGadget(AppMain::cntSubAddEdit,#True)
                    Main::SaveElement("Star")
                    Done = #True
                  EndIf
                  Drawaction = Drawaction + 1  
              
                Case #PB_EventType_MouseMove
              
                  Select Drawaction
                    Case 0
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      SetGadgetText(Main::strOuterRadius,Str(AppMain::NewObject\OuterRadius))      
                      Process(x,y)  
                    Case 2
                      SetGadgetText(Main::strInnerRadius,Str(AppMain::NewObject\InnerRadius))   
                      Process(x,y)                     
                    ;Ready for rotation as polygon  
                      ;Case 3
                    ;  SetGadgetText(strAngle,Str(AppMain::NewObject\EndAngle))   
                    ;  Process(x,y)                        
                  EndSelect  
                  
              EndSelect ;EventType()   
            
          EndSelect ;EventGadget()
      
      EndSelect ;Event
        
   Until Done = #True 
    
  EndProcedure
    
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

  EndProcedure
  
  Procedure NewStar()
    
    
  Define dlgStarProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThickness.i,btnCancel.i,Quit.i
  
  Define Colour.i,SelectedColour.i
  
  Define Cancel.i = #False
  
  dlgStarProperties = OpenWindow(#PB_Any, 0, 0, 145, 210, "Star Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 10, 10, 90, 25, "Select Colour")
  cvsColour = CanvasGadget(#PB_Any, 110, 10, 25, 25, #PB_Canvas_Border)
  TextGadget(#PB_Any, 10, 55, 70, 20, "Transparency", #PB_Text_Right)
  spnTransp = SpinGadget(#PB_Any, 90, 50, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 85, 60, 20, "Thickness", #PB_Text_Right)   
  spnThickness = SpinGadget(#PB_Any, 80, 80, 50, 20, 1, 128, #PB_Spin_Numeric) 
  
  TextGadget(#PB_Any, 5, 115,50, 20, "Points", #PB_Text_Right)   
  spnSides = SpinGadget(#PB_Any, 80, 110, 50, 20, 3, 10, #PB_Spin_Numeric)    
      
  optFill = OptionGadget(#PB_Any, 10, 140, 40, 20, "Fill")
  optOutLine = OptionGadget(#PB_Any, 80, 140, 70, 20, "Outline")
       
  btnOk = ButtonGadget(#PB_Any, 20, 170, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 170, 50, 30, "Cancel")
  
  StickyWindow(dlgStarProperties, #True)  
  
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  SetGadgetState(optOutLine, 1)
  SetGadgetText(spnThickness,"1")
  SetGadgetText(spnSides,"3")
  
    Repeat
  
    LineEvent = WaitWindowEvent()
    Select LineEvent 
      Case #PB_Event_Gadget

        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case btnOk
            
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             ;SetGadgetState(Main::spnTrans,Alpha(SelectedColour) )           
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThickness))
             If GetGadgetState(optFill) = #True
               AppMain::NewObject\Filled = #True
             Else
               AppMain::NewObject\Filled = #False
             EndIf          
             AppMain::NewObject\Points = GetGadgetState(spnSides)
            AppMain::NewObject\Thickness = GetGadgetState(spnThickness)
            AppMain::NewObject\Colour =  SelectedColour
            Quit = #True
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgStarProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  DrawStar()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
  EndIf
  EndProcedure
    
  Procedure AddElements()
    
    Define Done.i, Used.i
    
    If Appmain::Drawmode = "Add"
      Height = 275
    Else
      Height = 300
    EndIf
    Define StartY.i
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
    
    TextGadget(#PB_Any, 5, 70,50, 20, "Points", #PB_Text_Right)   
    Main::spnSides = SpinGadget(#PB_Any, 80, 70, 50, 20, 3, 10, #PB_Spin_Numeric)    
    TextGadget(#PB_Any, 5, 105, 60, 20, "Thickness", #PB_Text_Right)   
    Main::spnThickness = SpinGadget(#PB_Any, 80, 100, 50, 20, 1, 128, #PB_Spin_Numeric)       
    Main::optFill = OptionGadget(#PB_Any, 10, 125, 40, 20, "Fill")
    Main::optOutLine = OptionGadget(#PB_Any, 80, 125, 70, 20, "Outline")
    TextGadget(#PB_Any, 60, 150, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 150, 20, 20, "Y", #PB_Text_Center)    
    TextGadget(#PB_Any, 15, 175, 35, 20, "Centre", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 170, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 170, 35, 20, "")       
    TextGadget(#PB_Any, 5, 200, 75, 20, "Outer Radius", #PB_Text_Right)
    Main::strOuterRadius = StringGadget(#PB_Any, 95, 195, 35, 20, "")
    TextGadget(#PB_Any, 5, 225, 75, 20, "Inner Radius", #PB_Text_Right)
    Main::strInnerRadius = StringGadget(#PB_Any, 95, 220, 35, 20, "")    
    TextGadget(#PB_Any, 5, 255, 45, 20, "Rotation", #PB_Text_Right)
    Main::strAngle = StringGadget(#PB_Any, 55, 245, 30, 20, "")
    If Appmain::Drawmode <> "Add"
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 270, 50, 25, "Redraw")     
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 270, 50, 25, "Delete")   
    EndIf     
  
      
    CloseGadgetList() 
    
    ;Set Defaults
    If AppMain::Drawmode = "Add"     
      SetGadgetText(Main::spnThickness,"1")
      SetGadgetText(Main::spnSides,"3")      
      SetGadgetText(Main::strStartX,"")
      SetGadgetText(Main::strStartY,"")
      SetGadgetText(Main::strOuterRadius, "")
      SetGadgetText(Main::strInnerRadius, "")      
      SetGadgetText(Main::strAngle, "")      
      SetGadgetState(Main::optOutLine, #True)       
     EndIf

  EndProcedure  
  
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 233
; FirstLine = 94
; Folding = H+
; EnableXP
; EnableUnicode