﻿;{ ==Code Header Comment==============================
;        Name/title: DrawText.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing of text on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawText
  
  Declare NewText()
  Declare AddElements()
  
EndDeclareModule

Module DrawText
  
  Global VFont.i
  
  Global DrawAction.i = -1
    
  Procedure GrabDrawnImage()
    ;{ ==Procedure Header Comment=========================
    ;        Name/title: GrabDrawnImage()
    ;       Description: Procedure to grab the existing canvas image
    ; ====================================================
    ;}   
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

  EndProcedure   
    
  Procedure DrawShape()
    ;{ ==Procedure Header Comment=========================
    ;        Name/title: DrawShape()
    ;       Description: Procedure to draw selected text on the canvas
    ; ====================================================
    ;} 
    Define Left.i,Top.i

    ;Clearcanvas
    ;DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
   
    If Not IsFont(VFont)
      VFont = LoadFont(#PB_Any, AppMain::NewObject\Font, 14)
    EndIf
    VectorFont(FontID(VFont), AppMain::NewObject\Thickness * 5)
    VectorSourceColor(AppMain::NewObject\Colour)
    
    Left = AppMain::NewObject\StartX - VectorTextWidth(AppMain::NewObject\Text)/2    
    Top = AppMain::NewObject\StartY - VectorTextHeight(AppMain::NewObject\Text)/2        
    MovePathCursor(Left,Top)
    If AppMain::NewObject\Filled = #True
      DrawVectorText(AppMain::NewObject\Text)
    Else
      AddPathText(AppMain::NewObject\Text)
      StrokePath(1) 
    EndIf

  EndProcedure
        
  Procedure Process(x.i,y.i)
    ;{ ==Procedure Header Comment=========================
    ;        Name/title: Process(x.i,y.i)
    ;       Description: Procedure to draw selected text on the canvas
    ; ====================================================
    ;}   
    If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
      ;Clearcanvas
      DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
      DrawShape() 
      StopVectorDrawing()
    EndIf
    
  EndProcedure
  
  Procedure AddText()
    
    Static OldX.i,OldY.i
    Done = #False

    Repeat
  
      Event = WaitWindowEvent()
      Used = #False
      
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
              
            Case AppMain::drgCanvas
              Used = #True
              ;Snap To grid
              X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
              Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
              If X < 0
                X = 0
              ElseIf X > 640
                X = 640
              EndIf
              If Y < 0
                Y = 0
              ElseIf Y > 640
                Y = 640
              EndIf
          
              Select EventType()
          
                Case #PB_EventType_LeftClick
                  
                  AppMain::NewObject\StartX = x
                  AppMain::NewObject\StartY = y
                  Process(x,y) 
                  Appmain::Drawmode = "Idle"                    
                  HideGadget(AppMain::cntSubAddEdit,#True)
                  Main::SaveElement("Text")
                  Done = #True                     
                
                Case #PB_EventType_MouseMove
                  
                  ;Only on significant move
                  If (x <> OldX) Or (y <> OldY) 
                    OldX = x
                    OldY = y
                    AppMain::NewObject\StartX = x
                    AppMain::NewObject\StartY = y
                    SetGadgetText(Main::strStartX,Str(X))      
                    SetGadgetText(Main::strStartY,Str(Y)) 
                    Process(x,y)
                  EndIf
                  
              EndSelect ;EventType()   
              
         ;   Case btnFont
         ;     FontName$ = "" 
         ;     FontRequester(FontName$, FontSize,0)
         ;     AppMain::Font = SelectedFontName()      
         ;     AppMain::NewObject\Font = SelectedFontName()
              
          EndSelect ;EventGadget()
      
      EndSelect ;Event
      
   ;   If Used = #False
   ;     Main::EventHandler(Event)
   ;   EndIf
        
    Until Done = #True

    
  EndProcedure
 
  Procedure NewText()
    
  Define dlgTextProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,strText.i,btnFont.i,spnThickness.i,optFill.i,optOutLine.i
  Define btnOk.i,btnCancel.i,Quit.i
  Define Colour.i,SelectedColour.i
  
  Define Cancel.i = #False
  
  dlgTextProperties = OpenWindow(#PB_Any, 0, 0, 145, 215, "Text Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

  btnSelectColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
  GadgetToolTip(Main::btnColour, "Select Element Colour")
  cvsColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
  spnTransp = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
  TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
  TextGadget(#PB_Any, 5, 70, 50, 20, "Insert Text", #PB_Text_Right)
  strText = StringGadget(#PB_Any, 5, 90, 60, 20, "AB")
  btnFont = ButtonGadget(#PB_Any, 80, 90, 50, 20, "Font")
  TextGadget(#PB_Any, 5, 120, 40, 20, "Size", #PB_Text_Right)
  spnThickness = SpinGadget(#PB_Any, 70, 120, 40, 20, 20, 128, #PB_Spin_Numeric) 
  optFill = OptionGadget(#PB_Any, 5, 145, 60, 20, "Filled")
  optOutLine = OptionGadget(#PB_Any, 70, 145, 70, 20, "Outlined")
  btnOk = ButtonGadget(#PB_Any, 20, 175, 50, 30, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 80, 175, 50, 30, "Cancel")
  
  StickyWindow(dlgTextProperties, #True)  
  
  ;Show Default Element Colour
  SelectedColour = RGBA(255,0,0,255)
  StartVectorDrawing(CanvasVectorOutput(cvsColour))
  VectorSourceColor(SelectedColour)
  AddPathBox(0,0,25,25) 
  FillPath()
  StopVectorDrawing()
  
  ;Show Default Values
  SetGadgetText(spnTransp,"255")  
  SetGadgetText(spnThickness,"20")   
  SetGadgetState(optOutLine, 1)
  AppMain::NewObject\Font = "Arial"
  AppMain::NewObject\Thickness = 20
  VFont = LoadFont(#PB_Any, AppMain::NewObject\Font, AppMain::NewObject\Thickness)
  
  Repeat
  
    LineEvent = WaitWindowEvent()
    Select LineEvent 
      Case #PB_Event_Gadget

        Select EventGadget()
          Case btnSelectColour
            Colour = ColorRequester()
            SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show selected colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
          Case spnTransp
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTransp))         
            StartVectorDrawing(CanvasVectorOutput(cvsColour))
            ;Clear Canvas
            VectorSourceColor(RGBA(255,255,255,255))
            AddPathBox(0,0,25,25) 
            FillPath()
            ;Show new colour
            VectorSourceColor(SelectedColour)
            AddPathBox(0,0,25,25) 
            FillPath()
            StopVectorDrawing()
            
          Case btnOk
            
             StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
               VectorSourceColor(SelectedColour)
               AddPathBox(0,0,25,25) 
               FillPath()
             StopVectorDrawing()         
             AppMain::NewObject\Colour =  SelectedColour           
             SetGadgetState(Main::spnTrans,Alpha(SelectedColour)) 
             SetGadgetText(Main::strText,GetGadgetText(strText))
             AppMain::NewObject\Text = GetGadgetText(strText)
             
             SetGadgetState(Main::spnThickness,GetGadgetState(spnThickness))
             SetGadgetText(Main::spnThickness,Str(GetGadgetState(spnThickness)))
             
             ;SetGadgetState(Main::spnThickness,45)
             ;SetGadgetText(Main::spnThickness,"45")
             AppMain::NewObject\Thickness =  GetGadgetState(spnThickness)       
             If GetGadgetState(optFill) = #True
               SetGadgetState(Main::optFill,#True)
               AppMain::NewObject\Filled = #True
             Else
               SetGadgetState(Main::optOutLine,#True)             
               AppMain::NewObject\Filled = #False
             EndIf
            Quit = #True
          Case btnCancel
            Cancel = #True
            Quit = #True
            
          Case btnFont
            FontName$ = "" 
            FontRequester(FontName$, FontSize,0)
            AppMain::NewObject\Font = SelectedFontName()           
            VFont = LoadFont(#PB_Any,AppMain::NewObject\Font, AppMain::NewObject\Thickness)             
        EndSelect
    EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgTextProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  GrabDrawnImage() 
  Drawaction = 0
  AddText()
 ; SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
 ; SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
  EndIf  
    
  EndProcedure

  Procedure AddElements()
    
    Define Done.i, Used.i
    
    If Appmain::Drawmode = "Add"
      Height = 220
    Else
      Height = 280
    EndIf
    Define StartY.i
    
    ;Remove any visible container 
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    
    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 135, 150, Height,#PB_Container_Single)
    
    ;Colour Selection
    Main::btnColour = ButtonGadget(#PB_Any, 5, 5, 100, 25, "Colour")
    GadgetToolTip(Main::btnColour, "Select Element Colour")
    Main::cnvColour = CanvasGadget(#PB_Any,115,5,25,25,#PB_Canvas_Border)
    Main::spnTrans = SpinGadget(#PB_Any, 90, 40, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 5, 45, 80, 20, "Transparency")
    TextGadget(#PB_Any, 5, 70, 50, 20, "Insert Text", #PB_Text_Right)
    Main::strText = StringGadget(#PB_Any, 5, 90, 60, 20, "AB")
    Main::optFill = OptionGadget(#PB_Any, 5, 145, 60, 20, "Filled")
    Main::optOutLine = OptionGadget(#PB_Any, 70, 145, 70, 20, "Outlined")
    Main::btnFont = ButtonGadget(#PB_Any, 80, 90, 50, 20, "Font")
    TextGadget(#PB_Any, 5, 120, 40, 20, "Size", #PB_Text_Right)
    Main::spnThickness = SpinGadget(#PB_Any, 70, 120, 40, 20, 20, 128, #PB_Spin_Numeric) 
    TextGadget(#PB_Any, 55, 170, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 95, 170, 20, 20, "Y", #PB_Text_Center)   
    TextGadget(#PB_Any, 5, 190, 45, 20, "Centre", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 185, 30, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 185, 30, 20, "")     
    If Appmain::Drawmode <> "Add"
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 250, 50, 25, "Redraw")      
      Main::btnDelete = ButtonGadget(#PB_Any, 90, 250, 50, 25, "Delete")     
    EndIf    
      
      CloseGadgetList() 
 
  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 338
; FirstLine = 105
; Folding = 4n-
; EnableXP
; EnableUnicode