﻿;{ ==Code Header Comment==============================
;        Name/title: DrawWarning.pbi
;   Executable name: Part of Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 16\05\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Module to handle drawing warning triangles on main form canvas
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule DrawWarning
  
 Declare NewWarning()
 Declare AddElements()
  
EndDeclareModule

Module DrawWarning
  
  Global spntrans.i
  
  Global strStartX, strStartY, OptFill, OptOutline, strAngle.i, btnOk, btnDone
   
  Global DrawAction.i = -1 
    
  Procedure DrawShape()
    
  Define Color1 = $FF000000    
  Define Color2 = $FF00FFFF     
    
  Color1 = RGBA(Red(Color1),Green(Color1),Blue(Color1),AppMain::NewObject\Trans)
  Color2 = RGBA(Red(Color2),Green(Color2),Blue(Color2),AppMain::NewObject\Trans)  
  
  SaveVectorState()
  RotateCoordinates(AppMain::NewObject\StartX, AppMain::NewObject\StartY, AppMain::NewObject\StartAngle)
   
  ;Centre
  VectorSourceColor(Color2)
  MovePathCursor(AppMain::NewObject\StartX , AppMain::NewObject\StartY - AppMain::NewObject\OuterRadius)
  AddPathLine(AppMain::NewObject\StartX - 0.8* AppMain::NewObject\OuterRadius , AppMain::NewObject\StartY + 0.6 * AppMain::NewObject\OuterRadius)
  AddPathLine(AppMain::NewObject\StartX + 0.8* AppMain::NewObject\OuterRadius, AppMain::NewObject\StartY + 0.6 * AppMain::NewObject\OuterRadius)
  ClosePath()
  FillPath()
  
  ;Change Colour for outer triangle and exclamation mark
  VectorSourceColor(Color1)
         
  ;Outer triangle
  MovePathCursor(AppMain::NewObject\StartX , AppMain::NewObject\StartY - AppMain::NewObject\OuterRadius)
  AddPathLine(AppMain::NewObject\StartX - 0.8* AppMain::NewObject\OuterRadius , AppMain::NewObject\StartY + 0.6 * AppMain::NewObject\OuterRadius)
  AddPathLine(AppMain::NewObject\StartX + 0.8* AppMain::NewObject\OuterRadius, AppMain::NewObject\StartY + 0.6 * AppMain::NewObject\OuterRadius)
  ClosePath()
  StrokePath(AppMain::NewObject\OuterRadius / 6.0, #PB_Path_RoundCorner)
         
  ;Exclamation Mark       
  MovePathCursor(AppMain::NewObject\StartX, AppMain::NewObject\StartY + 0.1 * AppMain::NewObject\OuterRadius)
  AddPathLine(AppMain::NewObject\StartX - (0.1 * AppMain::NewObject\OuterRadius), AppMain::NewObject\StartY - 0.5 * AppMain::NewObject\OuterRadius)
  AddPathCircle(AppMain::NewObject\StartX, AppMain::NewObject\StartY - 0.5 * AppMain::NewObject\OuterRadius, 0.1 * AppMain::NewObject\OuterRadius,180,0,#PB_Path_Connected )       
  ClosePath()
  AddPathCircle(AppMain::NewObject\StartX, AppMain::NewObject\StartY + 0.3 * AppMain::NewObject\OuterRadius, 0.1 * AppMain::NewObject\OuterRadius)
  FillPath()
  RestoreVectorState()

  EndProcedure 
    
  Procedure Process(x.i,y.i)
    
    Static Angle1.i
    
    If StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
      
      ;Clear canvas To Existing Drawing
      DrawVectorImage(ImageID(AppMain::DrawnImg), 255)
       
      VectorSourceColor(AppMain::NewObject\Colour)
      
      Select DrawAction
          
        Case 0  ;Set Centre Point
            
        Case 1 ;Set Outer Radius

          AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))
          DrawShape()
        
        Case 2
            
            ;Set rotation angle
            VectorSourceColor(RGBA($00,$FF,$00,$FF))
            AddPathCircle(AppMain::NewObject\StartX,AppMain::NewObject\StartY, AppMain::NewObject\OuterRadius , 0,360)     
            StrokePath(1)   
            
            ;Show Chose angle line           
            VectorSourceColor(RGBA($FF,$00,$00,$FF))
         
            MovePathCursor(AppMain::NewObject\StartX,AppMain::NewObject\StartY)
            AddPathLine(x,y)
            DashPath(1, 5)
            If x => AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
              If X - AppMain::NewObject\StartX = 0
                Angle1 = 90
              Else
                Angle1 = Degree(ATan((Y - AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
              EndIf
            ElseIf  x =< AppMain::NewObject\StartX And Y => AppMain::NewObject\StartY
              If Y-AppMain::NewObject\StartY = 0
                Angle1 = 180
              Else
                Angle1 = 90 + Degree(ATan((AppMain::NewObject\StartX-X)/(Y-AppMain::NewObject\StartY)))
              EndIf
            ElseIf  x =< AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY
              If X - AppMain::NewObject\StartX = 0
                Angle1 = 270
              Else
                Angle1 = 180 + Degree(ATan((Y-AppMain::NewObject\StartY)/(X - AppMain::NewObject\StartX)))
              EndIf
            ElseIf  x => AppMain::NewObject\StartX And Y =< AppMain::NewObject\StartY  
              Angle1 = 270 + Degree(ATan((X - AppMain::NewObject\StartX)/(AppMain::NewObject\StartY-Y)))
            EndIf
            AppMain::NewObject\StartAngle = Angle1
            ;Reset Vector colour
            VectorSourceColor(AppMain::NewObject\Colour)
            Drawshape()
  
          Case  3
            Drawshape()
          
             
       EndSelect 

    VectorSourceColor(AppMain::NewObject\Colour)
    StopVectorDrawing()
    
  EndIf
    
  EndProcedure   
    
  Procedure DrawWarning()

  Done = #False
  Static OldX.i,OldY.i
  
  Repeat
  
    Event = WaitWindowEvent()
    
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
              
          Case AppMain::drgCanvas
            ;Snap To grid
            X = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseX)/5) ,#PB_Round_Nearest) * 5
            Y = Round((GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_MouseY)/5),#PB_Round_Nearest) * 5
            If X < 0
              X = 0
            ElseIf X > 640
              X = 640
            EndIf
            If Y < 0
              Y = 0
            ElseIf Y > 640
              Y = 640
            EndIf
            
            Select EventType()
          
              Case #PB_EventType_LeftClick

                Select Drawaction
                  Case 0 
                    ;First Mouse Click Set Centre Point
                    AppMain::NewObject\StartX = X
                    AppMain::NewObject\StartY = Y
                    SetGadgetText(Main::strStartX,Str(AppMain::NewObject\StartX))      
                    SetGadgetText(Main::strStartY,Str(AppMain::NewObject\StartY))                   
                    Drawaction = Drawaction + 1
              
                  Case 1
                    ;Second Click Set Radius
                    AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))           
                    Drawaction = Drawaction + 1
 
                  Case 2
                    ;Third Click Set Rotation
                    SetGadgetText(Main::strAngle,Str(AppMain::NewObject\StartAngle))   
                    Drawaction = Drawaction + 1 
                    Process(x,y) 
                    Appmain::Drawmode = "Idle"                    
                    HideGadget(AppMain::cntSubAddEdit,#True)
                    Main::SaveElement("Warning")
                    Done = #True
                    
                    Drawaction = Drawaction + 1             
                EndSelect
                
              Case #PB_EventType_MouseMove
                
                ;Only on significant move
                If (x <> OldX) Or (y <> OldY) 
                  OldX = x
                  OldY = y
                  
                  Select Drawaction
                    Case 0
                      ;Show Centre Point Dynamic
                      SetGadgetText(Main::strStartX,Str(X))      
                      SetGadgetText(Main::strStartY,Str(Y))  
                    Case 1 
                      ;Show Radius Dynamic
                      AppMain::NewObject\OuterRadius = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))           
                      Process(x,y) 
                      SetGadgetText(Main::strRadius,Str(AppMain::NewObject\OuterRadius))
                   Case 2 
                     ;Third Show Rotation Angle
                     AppMain::NewObject\StartAngle = Sqr(Pow((AppMain::NewObject\StartX-X),2) + Pow((AppMain::NewObject\StartY-Y),2))           
                     Process(x,y) 
                     SetGadgetText(Main::strAngle,Str(AppMain::NewObject\StartAngle))

                  EndSelect ;Drawaction
                  
                EndIf
                
            EndSelect  ;EventType()   
            
        EndSelect  ;EventGadget()
        
    EndSelect  ;Event 
   
  Until Done = #True  

  EndProcedure
  
  Procedure GrabDrawnImage()
       
    ;Create Drawn Image 
    AppMain::DrawnImg = CreateImage(#PB_Any, 640,640, 32)
    If StartDrawing(ImageOutput(AppMain::DrawnImg))
      DrawImage(GetGadgetAttribute(AppMain::drgCanvas, #PB_Canvas_Image), 0, 0)
      StopDrawing()
    EndIf

EndProcedure

  Procedure NewWarning()

    Define dlgWarningProperties.i,Event.i,btnSelectColour.i,cvsColour.i,spnTransp.i,spnThickness.i,btnCancel.i,Quit.i
  
    Define Colour.i,SelectedColour.i
  
    Define Cancel.i = #False
  
    dlgWarningProperties = OpenWindow(#PB_Any, 0, 0, 145, 80, "Warning Properties", #PB_Window_Tool| #PB_Window_WindowCentered)

    TextGadget(#PB_Any, 10, 15, 70, 20, "Transparency", #PB_Text_Right)
    spnTransp = SpinGadget(#PB_Any, 90, 10, 40, 20, 100, 255, #PB_Spin_ReadOnly | #PB_Spin_Numeric) 
    btnOk = ButtonGadget(#PB_Any, 20, 40, 50, 30, "Ok")
    btnCancel = ButtonGadget(#PB_Any, 80, 40, 50, 30, "Cancel")
  
    StickyWindow(dlgWarningProperties, #True)  
    
    ;Show Default Values
    SetGadgetText(spnTransp,"255")
    
    Repeat
  
    LineEvent = WaitWindowEvent()
    Select LineEvent 
      Case #PB_Event_Gadget

        Select EventGadget()

          Case btnOk
            
            AppMain::NewObject\Trans =  GetGadgetState(spnTransp)
            SetGadgetText(Main::spntrans,Str(AppMain::NewObject\Trans))
            AppMain::NewObject\StartAngle = 0
             Quit = #True
             
          Case btnCancel
            Cancel = #True
            Quit = #True
        EndSelect
     EndSelect
      
  Until Quit = #True
  
  CloseWindow(dlgWarningProperties)
  
  If Not Cancel
  ;Start the drawing operation
  ;Get the image drawn so far
  SetGadgetText(Main::spnTrans,Str(AppMain::NewObject\Trans)) 
  GrabDrawnImage() 
  Drawaction = 0
  DrawWarning()
  SetGadgetColor(Main::strStartX, #PB_Gadget_BackColor,RGB(255,255,255))
  SetGadgetColor(Main::strStartY, #PB_Gadget_BackColor,RGB(255,255,255))                

  AppMain::Drawmode = "Idle"
  EndIf
EndProcedure

  Procedure AddElements()
    
    Define Height.i,Done.i, Used.i
    
    If Appmain::Drawmode = "Add"
      Height = 155
    Else
      Height = 180
    EndIf
    
    If IsGadget(Main::cntSubAddEdit)
      FreeGadget(Main::cntSubAddEdit)
    EndIf
    Main::cnvColour = -2

    ;Recreate the edit container
    UseGadgetList(WindowID(Main::MainWnd))
    Main::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 140, 150,Height, #PB_Container_Single)
    TextGadget(#PB_Any, 5, 5, 80, 20, "Transparency")   
    Main::spnTrans = SpinGadget(#PB_Any, 90, 10, 50, 20, 100, 255, #PB_Spin_Numeric)
    TextGadget(#PB_Any, 60, 35, 20, 20, "X", #PB_Text_Center)    
    TextGadget(#PB_Any, 100, 35, 20, 20, "Y", #PB_Text_Center)    
    TextGadget(#PB_Any, 15, 45, 35, 20, "Centre", #PB_Text_Right)
    Main::strStartX = StringGadget(#PB_Any, 55, 50, 35, 20, "")
    Main::strStartY = StringGadget(#PB_Any, 95, 50, 35, 20, "")       
    TextGadget(#PB_Any, 15, 75, 35, 20, "Radius", #PB_Text_Right)
    Main::strRadius = StringGadget(#PB_Any, 55, 80, 30, 20, "")
    TextGadget(#PB_Any, 5, 105, 45, 20, "Rotation", #PB_Text_Right)
    Main::strAngle = StringGadget(#PB_Any, 55, 110, 30, 20, "")
    If Appmain::Drawmode <> "Add"
      Main::btnRedraw = ButtonGadget(#PB_Any, 20, 140, 50, 25, "Redraw")      
      Main::btnDelete = ButtonGadget(#PB_Any, 80, 140, 50, 25, "Delete")     
    EndIf   
      
    CloseGadgetList() 
    
    ;Set Defaults
    If AppMain::Drawmode = "Add"     
      
      SetGadgetText(Main::strStartX,"")
      SetGadgetText(Main::strStartY,"")
      SetGadgetText(Main::strRadius, "")
      SetGadgetText(Main::strAngle, "")      
   
    EndIf

  EndProcedure   
        
EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 62
; FirstLine = 57
; Folding = P+
; EnableXP