﻿;{ ==Code Header Comment==============================
;        Name/title: frmMain.pb
;   Executable name: Icondesigner.exe
;           Version: 1.0.0
;            Author: Collectordave
;     Collaborators: 
;    Translation by: 
;       Create date: 24\01\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.42LTS(x64)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Programme to use PB vector draw commands to build icons
; ====================================================
;.......10........20........30........40........50........60........70........80
;}
EnableExplicit
UseSQLiteDatabase()
UsePNGImageEncoder()

IncludeFile "AppModule.pbi"
IncludeFile "dlgNewGroup.pbi"


DeclareModule Main
  
  Global Dim Elements.AppMain::DrawObject(0)
  Global CurrentElement.i,ElementColour.i
  Global MainWnd.i
  
  ;Element Edit Gadgets
  Global cntSubAddEdit.i,btnColour.i,cnvColour.i,spnTrans.i,strText.i,btnFont.i,spnTextSize.i
  Global spnThickness.i,strStartX.i,strStartY.i,strEndX.i,strEndY.i,strRadius.i,optFill.i
  Global strRadius.i,optOutLine.i,spnSides.i,strAngle.i,strOuterRadius.i,strInnerRadius.i,btnRedraw.i,btnDelete.i
  Global spnAngle1.i,spnAngle2.i,strXRadius.i,strYRadius.i
  Global strMidX1.i,strMidY1.i,strMidX2.i,strMidY2.i,chkRound.i
  
  Global CurrentIcon.s

  Declare EventHandler(Event.i)
  Declare SaveElement(Type.s)
  Declare DrawShape(Destination.s)
  
EndDeclareModule

IncludeFile "dlgLoadIcon.pbi"
IncludeFile "dlgIconViewer.pbi"
IncludeFile "dlgNewShape.pbi"
IncludeFile "VDraw.pbi"
IncludeFile "DrawArc.pbi"
IncludeFile "DrawArrow Str.pbi"
IncludeFile "DrawArrowClock.pbi"
IncludeFile "DrawArrowCur.pbi"
IncludeFile "DrawUndoRedo.pbi"
IncludeFile "DrawBox.pbi"
IncludeFile "DrawCircle.pbi"
IncludeFile "DrawCurve.pbi"
IncludeFile "DrawEllipse.pbi"
IncludeFile "DrawLine.pbi"
IncludeFile "DrawText.pbi"
IncludeFile "DrawFlash.pbi"
IncludeFile "DrawMagnifier.pbi"
IncludeFile "DrawMoon.pbi"
IncludeFile "DrawPen.pbi"
IncludeFile "DrawPlus.pbi"
IncludeFile "DrawPoly.pbi"
IncludeFile "DrawStar.pbi"
IncludeFile "DrawTick.pbi"
IncludeFile "DrawWarning.pbi"
IncludeFile "HelpViewer.pbi"

Module Main

Global LoadIconWindow.i,ViewIconWindow.i,Event.i,cvsDrawing.i,txtCurrentIcon.i,strCurrentIcon.i

Global HelpWindow.i

Global cntSubAddEdit.i

Global Dim Elements.AppMain::DrawObject(0)
Global CurrentElement.i,btnAdd.i,btnEdit.i,btnDelete.i,CntButtons.i

;Colour Display\Selection
Global cntColour.i,SelectedColour.i

Global ShapesDB.i

Global SelectedShape_id.i,NumberOfElements.i,VFont.i,cntAddEdit.i,btnColour.i,strType.i

Global btnPrevious.i,btnNext.i,txtStatus.i

Enumeration FormMenu
  #mnuIconNewGroup
  #mnuIconNewIcon
  #mnuIconLoad
  #mnuIconSave
  #mnuIconViewSave
  #mnuIconExit
  #mnuDrawArc
  #mnuDrawBox
  #mnuDrawCircle
  #mnuDrawCurve
  #mnuDrawEllipse
  #mnuDrawLine
  #mnuDrawPath
  #mnuDrawText
  #mnuDrawArrowStr 
  #mnuDrawArrowClock
  #mnuDrawArrowCur
  #mnuDrawFlash
  #mnuDrawUndoRedo
  #mnuDrawMagnifier 
  #mnuDrawMoon
  #mnuDrawPen
  #mnuDrawPlus
  #mnuDrawPoly
  #mnuDrawStar
  #mnuDrawTick
  #mnuDrawWarning
  #mnuHelpShow
EndEnumeration

  Procedure SetColour(Colour.i)
    
    StartVectorDrawing(CanvasVectorOutput(Main::cnvColour))
    ;Clear Canvas
    VectorSourceColor(RGBA(255,255,255,255))
    AddPathBox(0,0,25,25) 
    FillPath()
    ;Show selected colour
    VectorSourceColor(Colour)
    AddPathBox(0,0,25,25) 
    FillPath()
    StopVectorDrawing()
    
  EndProcedure

  Procedure.i NewShape()
    
    Define Criteria.s,ShapeID.i
    
    Criteria = "SELECT * FROM Shapes WHERE Title = '" + NewShape::Name + "' AND Group_ID = " + Str(NewShape::Group_ID)
    If DatabaseQuery(AppMain::ShapesDB, Criteria)
      If FirstDatabaseRow(AppMain::ShapesDB) = 0
        Criteria = "INSERT INTO Shapes (Title,Group_ID)" +
                   " VALUES('" + NewShape::Name + "'," + Str(NewShape::Group_ID) + ");"

        DatabaseUpdate(AppMain::ShapesDB,Criteria)
        
        If DatabaseQuery(AppMain::ShapesDB, "SELECT * FROM Shapes WHERE Title = '" + NewShape::Name + "';") 
          FirstDatabaseRow(AppMain::ShapesDB)
          ShapeID = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Shape_ID"))
        EndIf      
      Else
        MessageRequester("Shapes","Shape Exists",#PB_MessageRequester_Ok)
        ProcedureReturn -1
      EndIf
    EndIf    
    
    ProcedureReturn ShapeID
    
  EndProcedure
  
  Procedure.i ConvertToGrey(Colour.i)
    
  #DefaultGrey = 100
  
  Define cRed.d,cGreen.d,cBlue.d,cAlpha.d
  
  ;Greyscale
  cRed = Red(Colour) * 0.3
  cGreen = Green(Colour) * 0.6
  cBlue = Blue(Colour) * 0.1
  cAlpha = Alpha(Colour) 
  cConvert = (cRed + cGreen + cBlue)
  If cConvert = 0
    cConvert = #DefaultGrey
  EndIf 

  ;Show greyscale
  rColour = RGBA(cConvert,cConvert,cConvert,cAlpha)

  ProcedureReturn rColour
  
EndProcedure
  
  
  Procedure ShowIcons()
    
    If IsWindow(ViewIconWindow)  
      If IsImage(AppMain::IconImg)
        FreeImage(AppMain::IconImg) 
      EndIf 
      If IsImage(AppMain::IconGreyImg)
        FreeImage(AppMain::IconGreyImg) 
      EndIf      
     AppMain::IconImg = CreateImage(#PB_Any, 640,640, 32,#PB_Image_Transparent)
     AppMain::IconGreyImg = CreateImage(#PB_Any, 640,640, 32,#PB_Image_Transparent)     
     DrawShape("Icon")
     IconView::Show()
    EndIf
  
  EndProcedure

  Procedure EditGadgets(Type.s)
    
    Select Type ;GetGadgetText(strType)

      Case "Arc"
        DrawArc::AddElements()
        
      Case "Box"
        DrawBox::AddElements()        
        
      Case "Curve"
        DrawCurve::AddElements()               
        
      Case "Circle"
        DrawCircle::AddElements()
        
      Case "Ellipse"
        DrawEllipse::AddElements()       
      
      Case "Line"
        DrawLine::AddElements()
        
      Case "Text"
        DrawText::AddElements()
         
      Case "ArrowClk"
        DrawArrowClock::AddElements()   
         
      Case "ArrowCur"
        DrawArrowCur::AddElements() 
        
      Case "ArrowStr"
        DrawArrowStr::AddElements()  
        
      Case "UndoRedo"
        DrawUnDoReDo::AddElements() 
        
       Case  "Flash"
        DrawFlash::AddElements()          
        
      Case  "Magnifier"
        DrawMagnifier::AddElements()        
        
      Case "Moon"
        DrawMoon::AddElements()     
        
      Case "Pen"
        DrawPen::AddElements() 
        
      Case "Plus"
        DrawPlus::AddElements() 
        
      Case "Poly"
        DrawPoly::AddElements()   
        
      Case "Star"
        DrawStar::AddElements()  
        
      Case "Tick"
        DrawTick::AddElements()  
        
      Case "Warning"
        DrawWarning::AddElements()    
        
      Default
       HideGadget(AppMain::cntSubAddEdit,#True)   
    
    EndSelect
  
  EndProcedure

  Procedure OpenShapesDB()
  
    Define DataBaseFile.s
    
    DatabaseFile = GetCurrentDirectory() +"Database\Shapes.spb"
   
    AppMain::ShapesDB = OpenDatabase(#PB_Any, DatabaseFile, "", ";")
  
  EndProcedure 
 
  Procedure Save()
    
    Define Criteria.s

    If SelectedShape_id > 0
      
      Criteria = "DELETE FROM DrawPoints WHERE Shape_ID = " + Str(SelectedShape_id) + " ;"
      DatabaseUpdate(AppMain::ShapesDB,Criteria)

      For iLoop = 0 To ArraySize(Elements())
      Criteria = "INSERT INTO DrawPoints (Shape_ID,DrawOrder,PathType,DrawText,StartX,StartY,MidX1,MidY1,MidX2,MidY2,EndX,EndY,OuterRadius,InnerRadius,StartAngle,EndAngle,Colour,Thickness,Filled,Points,Font,Trans,Round)"
      Criteria = Criteria + " VALUES(" +
                 Str(SelectedShape_id) +
                 "," + Str(iLoop) +
                 ",'" + Elements(iLoop)\Type + "'" +
                 ",'" + Elements(iLoop)\Text + "'" +
                 "," + Str(Elements(iLoop)\StartX) +
                 "," + Str(Elements(iLoop)\StartY) +
                 "," + Str(Elements(iLoop)\MidX1) +
                 "," + Str(Elements(iLoop)\MidY1) +      
                 "," + Str(Elements(iLoop)\MidX2) +      
                 "," + Str(Elements(iLoop)\MidY2) +      
                 "," + Str(Elements(iLoop)\EndX) +
                 "," + Str(Elements(iLoop)\EndY) +      
                 "," + Str(Elements(iLoop)\OuterRadius) +      
                 "," + Str(Elements(iLoop)\InnerRadius) +       
                 "," + Str(Elements(iLoop)\StartAngle) +      
                 "," + Str(Elements(iLoop)\EndAngle) +  
                 "," + Str(Elements(iLoop)\Colour) +       
                 "," + Str(Elements(iLoop)\Thickness) +      
                 "," + Str(Elements(iLoop)\Filled) +  
                 "," + Str(Elements(iLoop)\Points) +                
                 ",'" + Elements(iLoop)\Font + 
                 "'," + Elements(iLoop)\Trans +    
                 "," + Elements(iLoop)\Round +            
                 ");"
      If DatabaseUpdate(AppMain::ShapesDB,Criteria) = 0

        MessageRequester("Error", "Can't execute the query: " + DatabaseError())

      EndIf  
        
      Next iLoop
    
    Else
      
      MessageRequester("Save Error","No Shape Selected",#PB_MessageRequester_Ok  )
      
    EndIf
    
  EndProcedure
  
  Procedure LoadElements()
    
    NumberOfElements = 0   
    CurrentElement = 0  

    If DatabaseQuery(AppMain::ShapesDB, "SELECT * FROM DrawPoints WHERE Shape_ID = " + StrU(SelectedShape_id) + " ORDER BY draworder ASC;")
        
      While NextDatabaseRow(AppMain::ShapesDB)
        ReDim Elements(NumberOfElements)
        Elements(NumberOfElements)\Type = GetDatabaseString(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "PathType"))
        Elements(NumberOfElements)\Text = GetDatabaseString(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "DrawText"))          
        Elements(NumberOfElements)\StartX = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "StartX"))
        Elements(NumberOfElements)\StartY = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "StartY"))
        Elements(NumberOfElements)\MidX1 = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "MidX1"))
        Elements(NumberOfElements)\MidY1 = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "MidY1"))      
        Elements(NumberOfElements)\MidX2 = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "MidX2"))
        Elements(NumberOfElements)\MidY2 = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "MidY2"))     
        Elements(NumberOfElements)\EndX = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "EndX"))
        Elements(NumberOfElements)\EndY = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "EndY"))
        Elements(NumberOfElements)\StartAngle = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "StartAngle"))
        Elements(NumberOfElements)\EndAngle = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "EndAngle"))     
        Elements(NumberOfElements)\Colour = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Colour"))
        Elements(NumberOfElements)\OuterRadius = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "OuterRadius"))
        Elements(NumberOfElements)\InnerRadius = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "InnerRadius"))
        Elements(NumberOfElements)\Thickness = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Thickness"))
        Elements(NumberOfElements)\Filled = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Filled"))     
        Elements(NumberOfElements)\Points = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Points"))     
        Elements(NumberOfElements)\Font = GetDatabaseString(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Font"))     
        Elements(NumberOfElements)\Trans = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Trans"))
        Elements(NumberOfElements)\Round = GetDatabaseLong(AppMain::ShapesDB, DatabaseColumnIndex(AppMain::ShapesDB, "Round"))
      
        NumberOfElements = NumberOfElements + 1 

      Wend
      
      FinishDatabaseQuery(AppMain::ShapesDB) 
  EndIf
        
EndProcedure

  Procedure ShowElements()
  
    Define lblStatus.s
    
    DisableGadget(btnNext,#False)
    DisableGadget(btnPrevious,#False)    
    
    If NumberOfElements = 0
      lblStatus = "0 Of 0"
      DisableGadget(btnNext,#True)
      DisableGadget(btnPrevious,#True) 
      SetGadgetText(txtStatus,lblStatus)     
    ElseIf CurrentElement = 0 
      lblStatus = "1 Of " + Str(NumberOfElements)      
      DisableGadget(btnPrevious,#True) 
    ElseIf CurrentElement + 1 = NumberOfElements  
      lblStatus = Str(CurrentElement + 1) + " Of " + Str(NumberOfElements)       
      DisableGadget(btnNext,#True)
    Else
      DisableGadget(btnNext,#False)
      DisableGadget(btnPrevious,#False)       
      lblStatus = Str(CurrentElement + 1) + " Of " + Str(NumberOfElements)  
    EndIf
    
    ;Which Icon is loaded?
    SetGadgetText(strCurrentIcon,CurrentIcon)
    SetGadgetText(txtStatus,lblStatus)
    SetGadgetText(strType,Elements(CurrentElement)\Type)
    
    ;Add Code to display selected element detail
    EditGadgets(Elements(CurrentElement)\Type) ;Add The Edit Gadgets For The Selected Element
    
    ;Show Selected Settings
    SelectedColour = Elements(CurrentElement)\Colour

    ;Next depend on element type
    Select Elements(CurrentElement)\Type
        
      Case "Arc"
        DrawArc::AddElements()
        SetColour(Elements(CurrentElement)\Colour) 
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))       
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius))
        SetGadgetText(spnAngle1,Str(Elements(CurrentElement)\StartAngle))
        SetGadgetText(spnAngle2,Str(Elements(CurrentElement)\EndAngle))        
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf       
        
      Case "Box"
        DrawBox::AddElements()
        SetColour(Elements(CurrentElement)\Colour)     
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))        
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strEndX,Str(Elements(CurrentElement)\EndX))
        SetGadgetText(strEndY,Str(Elements(CurrentElement)\EndY))
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf       
        
      Case "Circle"
        DrawCircle::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))         
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius))
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf       
        
      Case "Curve"
        DrawCurve::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))        
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strEndX,Str(Elements(CurrentElement)\EndX))
        SetGadgetText(strEndY,Str(Elements(CurrentElement)\EndY))
        SetGadgetText(strMidX1,Str(Elements(CurrentElement)\MidX1))
        SetGadgetText(strMidY1,Str(Elements(CurrentElement)\MidY1))
        SetGadgetText(strMidX2,Str(Elements(CurrentElement)\MidX2))
        SetGadgetText(strMidY2,Str(Elements(CurrentElement)\MidY2))     

        
       Case "Ellipse"
        DrawEllipse::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))        
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strXRadius,Str(Elements(CurrentElement)\InnerRadius))            
        SetGadgetText(strYRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf       
        
      Case "Line"
        DrawLine::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))       
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strEndX,Str(Elements(CurrentElement)\EndX))
        SetGadgetText(strEndY,Str(Elements(CurrentElement)\EndY))
        SetGadgetState(chkRound,Elements(CurrentElement)\Round)
        
      Case "Text"
        DrawText::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))       
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)
        SetGadgetText(spnThickness,Str(Elements(CurrentElement)\Thickness))       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strText,Elements(CurrentElement)\Text) 
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf
        
      Case "Straight Arrow"
        DrawArrowStr::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strEndX,Str(Elements(CurrentElement)\EndX))
        SetGadgetText(strEndY,Str(Elements(CurrentElement)\EndY))        
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))         
        
      Case "Clock Arrow"
        DrawArrowClock::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius))       
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))         
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf      
        
      Case "Curved Arrow"
        DrawArrowCur::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius))       
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))         
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf
        
      Case "UndoRedo"
        DrawUndoRedo::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius))
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))         
        
      Case "Flash"
        DrawFlash::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))       
        
      Case "Magnifier"
        DrawMagnifier::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))        
        
      Case "Moon"
        DrawMoon::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))  
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle)) 
        
       Case "Pen"
        DrawPen::AddElements()
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Trans)) 
        SetGadgetText(spnTrans,Str(Elements(CurrentElement)\Trans))        
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))       
        
      Case "Plus"  
        DrawPlus::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))         
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        
      Case "Poly"  
        DrawPoly::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))        
        SetGadgetState(spnSides,Elements(CurrentElement)\Points)        
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)        
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle))         
        SetGadgetState(chkRound,Elements(CurrentElement)\Round)      
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf       
        
      Case "Star" 
        DrawStar::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))         
        SetGadgetState(spnSides,Elements(CurrentElement)\Points)         
        SetGadgetState(spnThickness,Elements(CurrentElement)\Thickness)       
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strOuterRadius,Str(Elements(CurrentElement)\OuterRadius))    
        SetGadgetText(strInnerRadius,Str(Elements(CurrentElement)\InnerRadius))
        If Elements(CurrentElement)\Filled = #True
          SetGadgetState(optFill,#True)
        Else
          SetGadgetState(optOutLine,#True) 
        EndIf
        
      Case "Tick"
        DrawTick::AddElements()
        SetColour(Elements(CurrentElement)\Colour)
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Colour)) 
        SetGadgetText(spnTrans,Str(Alpha(Elements(CurrentElement)\Colour)))        
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius))
        
      Case "Warning"
        DrawWarning::AddElements()
        SetGadgetState(spnTrans,Alpha(Elements(CurrentElement)\Trans)) 
        SetGadgetText(spnTrans,Str(Elements(CurrentElement)\Trans))        
        SetGadgetText(strStartX,Str(Elements(CurrentElement)\StartX))
        SetGadgetText(strStartY,Str(Elements(CurrentElement)\StartY))
        SetGadgetText(strRadius,Str(Elements(CurrentElement)\OuterRadius)) 
        SetGadgetText(strAngle,Str(Elements(CurrentElement)\StartAngle)) 
   
    EndSelect
    
  EndProcedure
  
  Procedure DrawArrowStr(x1,y1,x2,y2,Rotation = 0)
    
    Define Width.i = x2 - x1
    Define Height.i = y2 - y1    
    
    If Width < 5
      Width = 5
    EndIf
    If Height < 5
      Height = 5
    EndIf    
    SaveVectorState()
      RotateCoordinates(x1, y1 , Rotation)
      MovePathCursor(x1, y1)
      AddPathLine   (x1-(Width/2),y1+(Height/8))
      AddPathLine   (x1+(Width/2), y1+(Height/8))
      ClosePath()
      FillPath      ()
      MovePathCursor(x1, y1+(Height/8))
      AddPathLine   (x1,y1 + Height)
      StrokePath    (Width / 4)     
      RestoreVectorState()
      
    EndProcedure
    
  Procedure DrawArrowClock (x, y, Radius.i, Flip.i=#False,Rotation.i=0)

      Protected  hw.d, half.d, third.d
      Protected Size.i
      
      Size = Radius * 2
      Top =  y - (Size/2)
      Left = x - (Size/2)
      
      hw = Size / 12.0
      half = Size / 2.0
      third = Size / 3.0

      SaveVectorState()
      RotateCoordinates(X, Y , Rotation)
      If Flip = #False
        Debug "Coords Flipped"
        FlipCoordinatesX(x)
      EndIf 
      
      MovePathCursor(Left + hw, Top + (half-hw))
      AddPathCurve(Left + third,  Top + hw, Left + (Size-third),  Top + hw, Left + (Size-1.75*hw), Top + (half-2.0*hw))
      StrokePath(2.0 * hw)
      
      MovePathCursor(  Left + Size, Top + (half-hw))
      AddPathLine   (Left + (Size-hw-third), Top + (half-0.5*hw))
      AddPathLine   (Left + (Size-1.5*hw), Top)
      ClosePath()
      FillPath()
      RestoreVectorState() 
      
   EndProcedure     
    
  Procedure DrawArrowCur (x, y, Radius.i, Flip.i=#False,Rotation.i=0)
     
    Left = x - Radius/2
    Top = y - Radius/2
  
    Protected p.d = Radius / 32
    Protected p2.d = Radius / 2
    Protected p4.d = Radius / 4

    SaveVectorState()
    RotateCoordinates(x, y, rotation)    
    If Flip   = #True
      FlipCoordinatesX(x)
    EndIf
    MovePathCursor(Left + (p * 19), Top + (p * 7))
    AddPathLine   (Left + (p * 31), Top + (p * 19))
    AddPathLine   (Left + (p * 19), Top + (p * 31))
    ClosePath     ()
    FillPath      ()
    MovePathCursor(Left + p4,  Top +   p)
    AddPathArc    (Left +p4,  Top +  ( p * 19), Left +(p * 21), Top +(p * 19), p * 11)
    AddPathLine   (Left +(p * 24), Top +  (p * 19))
    StrokePath    (p * 10)
    RestoreVectorState()
  
EndProcedure
    
  Procedure DrawUndoRedo(x,y,Radius.i,Rotation = 0)
    
    Left = x - Radius/2
    Top = y - Radius/2

    Protected p.d  = Radius / 32
    Protected p8.d = Radius / 8
    Protected p4.d = Radius / 4
    SaveVectorState()
    RotateCoordinates(x, y , Rotation)
    MovePathCursor(Left, Top +(p4 + p))
    AddPathArc    (Left +(Radius - p8), Top+(p4+p), Left +(Radius - p8), Top + (Radius - p4 - p), p4 - p)
    AddPathArc    (Left +(Radius - p8), Top + (Radius - p4 - p), Left + p8, Top + (Radius - p4 - p), p4 - p)
    AddPathLine   (Left + (p4 - p), Top + (Radius - p4 - p))
    StrokePath    (p8 * 1.5)
    MovePathCursor(Left + (p4 - p), Top + (Radius - p4 - p)+(p8 * 1.5))
    AddPathLine   (Left, Top + (Radius - p4 - p))     
    AddPathLine   (Left + (p4 - p), Top + (Radius - p4 - p)-(p8 * 1.5))
    ClosePath()
    FillPath()
    RestoreVectorState() 
      
  EndProcedure 
  
  Procedure DrawMagnifier(x,y,Radius.i,Rotation = 0)
    
    SaveVectorState()
    RotateCoordinates(x, y, rotation)
    MovePathCursor(0.98 * x , 1.02 * y)
    AddPathLine   (x - 0.7 * Radius, y + 0.7 * Radius)
    StrokePath(0.2 * Radius)     
    AddPathCircle(x + 0.3 * Radius, y - 0.3 * Radius, 0.5 * Radius)
    StrokePath(0.1 * Radius)
    RestoreVectorState()
    
  EndProcedure
  
  Procedure DrawFlash(x,y,Radius.i,Rotation = 0)
    ;{ Procedure Comment
    ;       Author: Davido
    ;  Modyfied By: Collectordave
    ;} 
    
    Define Size.i = Radius * 2
    
    SaveVectorState()
    RotateCoordinates(x, y, Rotation)
    MovePathCursor(x + 0.09375 * Size, y - 0.4375* Size)
    AddPathLine(x - 0.21875 * Size, y  + 0.0625 * Size)
    AddPathLine(x - 0.0625 * Size, y + 0.0625 * Size)
    AddPathLine(x - 0.0625 * Size, y + 0.4375 * Size)
    AddPathLine(x + 0.25 * Size, y - 0.0625 * Size)
    AddPathLine(x + 0.09375 * Size, y - 0.0625 * Size)
    ClosePath()
    FillPath()
    RestoreVectorState() 
      
  EndProcedure
  
  Procedure DrawMoon (x, y, Radius, Rotation=0)
    ; [by Little John]

    SaveVectorState()
    RotateCoordinates(x, y, rotation)
    AddPathCircle(x, y, Radius/2, 287, 73, #PB_Path_CounterClockwise)
    AddPathCircle(x+0.3*Radius, y, Radius/2, 108, 252, #PB_Path_Connected)
    RestoreVectorState()
    FillPath()
      
EndProcedure

Procedure DrawPen(x,y,Radius, Trans.i,Rotation.i= 0)
  
    Protected Color1 = RGBA(0,0,255,AppMain::NewObject\Trans)
    Protected Color2 = RGBA(255,0,0,AppMain::NewObject\Trans) 
    Protected Size.i = Radius * 2    
  
    If AppMain::GreyScale = #True
      Color1 = ConvertToGrey(RGBA(Red(Color1),Green(Color1),Blue(Color1),Trans))
      Color2 = ConvertToGrey(RGBA(Red(Color2),Green(Color2),Blue(Color2),Trans)) 
    Else
      Color1 = RGBA(Red(Color1),Green(Color1),Blue(Color1),Trans)
      Color2 = RGBA(Red(Color2),Green(Color2),Blue(Color2),Trans) 
    EndIf
    
    SaveVectorState()
    RotateCoordinates(x, y, Rotation)
  
    VectorSourceColor(Color1)
      
    MovePathCursor(x +  4/64*Size, y - 10/64 * size)
    AddPathLine   (x +  1/64*Size, y -  1/64 * size)
    AddPathLine   (x + 10/64*Size, y -  4/64 * size)
    ClosePath()
    FillPath()
      
    MovePathCursor(x + 43/64 * size, y - 43/64 * size)
    AddPathLine   (x + 10/64 * size , y - 10/64 * size)
    StrokePath    (12/64 * size)
      
    VectorSourceColor(Color2)
    MovePathCursor(x + 46/64 * Size, y - 46/64 * size)
    AddPathLine   (x + 43/64 * Size, y - 43/64 * size)
    StrokePath    (12/64 * Size)
      
    VectorSourceColor(Color1)
    MovePathCursor(x + 58/64 * Size, y - 58/64 * Size)
    AddPathLine   (x + 46/64 * Size, y - 46/64 * Size)
    StrokePath    (12/64 * Size)
    RestoreVectorState()
    
EndProcedure


  Procedure DrawPolyGon(x1,y1,Points,Angle,Radius,FillOut.i,Thick.i,Round.i,Colour.i)
    
    Define Rotate.d
    Define Trans.i,dColour.i
    Trans = Alpha(Colour)
    
    If AppMain::GreyScale = #True
      dColour = ConvertToGrey(RGBA(Red(Colour),Green(Colour),Blue(Colour),255))
    Else
      dColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),255)
    EndIf   

    BeginVectorLayer(Trans)
    
    VectorSourceColor(dColour)
    
    RotateCoordinates(x1, y1,Angle)
    Rotate = 360/Points
    
    MovePathCursor(x1,y1-Radius)
    For k = 1 To Points - 1
      RotateCoordinates(x1, y1, Rotate)
      AddPathLine(x1, y1-Radius)
    Next
    ClosePath()  

    If  FillOut = #True
      If Round  = #True
        FillPath(#PB_Path_Preserve)
        StrokePath(Thick, #PB_Path_RoundCorner) 
      Else
        FillPath()
      EndIf
    Else
      If Round  = #True
        StrokePath(Thick, #PB_Path_RoundCorner) 
      Else
        StrokePath(Thick)
      EndIf     
    EndIf 
    EndVectorLayer()  
    
  EndProcedure 

  Procedure DrawPlusSign(x,y,Radius)

    Define Width.i = (Radius/5)*2
    MovePathCursor(x - Radius, y)
    AddPathLine   (x + Radius, y)
    MovePathCursor(x, y - Radius)
    AddPathLine   (x, y + Radius)
    StrokePath(Width)

  EndProcedure

  Procedure DrawStar(X.i,Y.i,Points.i,OutRadius.i,InnerRadius.i,Thick.i,Filled.i)
    
    Define Rotate.d
    Define k.i
    SaveVectorState()
    
    Rotate = 360/(Points * 2)
    
    MovePathCursor(X,Y - OutRadius)
    For k = 1 To Points * 2
      RotateCoordinates(X, Y, Rotate)
        If k & 1 = 1
          AddPathLine(X, Y - InnerRadius)
       Else
          AddPathLine(X, Y - OutRadius)
       EndIf
    Next
    ClosePath()  
    RestoreVectorState()
    If  Filled = #True
      FillPath()
    Else
      StrokePath(Thick * 5)
    EndIf 
 
   EndProcedure  

  Procedure DrawTick (x.i, y.i,Radius.i)
  
    Define Width.i = Radius/2
    
    If Width < 1
      Width = 1
    EndIf
    
    MovePathCursor(X - Radius, (Y + (Radius/8)))
    AddPathLine   (X , Y+Radius)
    AddPathLine   (X + Radius,Y-Radius)
    StrokePath(Width)  
      
  EndProcedure
 
  Procedure DrawWarning (x,y,Radius, Trans.i,Rotation.i= 0)
    
  Define Color1 = $FF000000    
  Define Color2 = $FF00FFFF     
  
  If AppMain::GreyScale = #True
    Color1 = ConvertToGrey(RGBA(Red(Color1),Green(Color1),Blue(Color1),Trans))
    Color2 = ConvertToGrey(RGBA(Red(Color2),Green(Color2),Blue(Color2),Trans)) 
  Else
    Color1 = RGBA(Red(Color1),Green(Color1),Blue(Color1),Trans)
    Color2 = RGBA(Red(Color2),Green(Color2),Blue(Color2),Trans) 
  EndIf

  SaveVectorState()
  RotateCoordinates(X, Y, Rotation)
   
  ;Centre
  VectorSourceColor(Color2)
  MovePathCursor(X , Y - Radius)
  AddPathLine(X - 0.8* Radius , Y + 0.6 * Radius)
  AddPathLine(X + 0.8* Radius, Y + 0.6 * Radius)
  ClosePath()
  FillPath()
  
  ;Change Colour for outer triangle and exclamation mark
  VectorSourceColor(Color1)
         
  ;Outer triangle
  MovePathCursor(X , Y - Radius)
  AddPathLine(X - 0.8* Radius , Y + 0.6 * Radius)
  AddPathLine(X + 0.8* Radius, Y + 0.6 * Radius)
  ClosePath()
  StrokePath(Radius / 6.0, #PB_Path_RoundCorner)
         
  ;Exclamation Mark       
  MovePathCursor(X, Y + 0.1 * Radius)
 ; AddPathLine(x-0.1*Radius, Y - 0.5*Radius) 
  AddPathLine(X - (0.1 * Radius), Y - 0.5 * Radius)
  AddPathCircle(X, Y - 0.5 * Radius, 0.1 * Radius,180,0,#PB_Path_Connected )       
  ClosePath()
  AddPathCircle(X, Y + 0.3 * Radius, 0.1 * Radius)
  FillPath()
  RestoreVectorState()

  EndProcedure
  


  Procedure DrawIcon()
    
      If NumberOfElements > 0
    
      For iLoop = 0 To NumberOfElements - 1
        
        If AppMain::GreyScale = #True
          NewColour = ConvertToGrey(Elements(iLoop)\Colour)
          VectorSourceColor(NewColour)
        Else
          VectorSourceColor(Elements(iLoop)\Colour)
        EndIf
        
        Select Elements(iLoop)\Type
            
          ;Elements First  
          Case "Arc"
          
            AddPathCircle(Elements(iLoop)\StartX,Elements(iLoop)\StartY, Elements(iLoop)\OuterRadius, Elements(iLoop)\StartAngle, Elements(iLoop)\EndAngle)
            If Elements(iLoop)\Filled = #True
              FillPath()
            Else
             StrokePath(Elements(iLoop)\Thickness * 5)
            EndIf           
            
          Case "Box"
          
            MovePathCursor(Elements(iLoop)\StartX,Elements(iLoop)\StartY)
            AddPathBox(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\EndX - Elements(iLoop)\StartX,Elements(iLoop)\EndY - Elements(iLoop)\StartY)
            If Elements(iLoop)\Filled = #True
              FillPath()
            Else
              StrokePath(Elements(iLoop)\Thickness * 5)
            EndIf            
          
          Case "Circle"
          
            AddPathCircle(Elements(iLoop)\StartX,Elements(iLoop)\StartY, Elements(iLoop)\OuterRadius, Elements(iLoop)\StartAngle, Elements(iLoop)\EndAngle)
            If Elements(iLoop)\Filled = #True
              FillPath()
            Else
              StrokePath(Elements(iLoop)\Thickness * 5)
            EndIf
            
          Case "Curve"
          
            MovePathCursor(Elements(iLoop)\StartX,Elements(iLoop)\StartY)
            AddPathCurve(Elements(iLoop)\MidX1,Elements(iLoop)\MidY1, Elements(iLoop)\MidX2,Elements(iLoop)\MidY2,Elements(iLoop)\EndX,Elements(iLoop)\EndY)
            If Elements(iLoop)\Filled = #True
              FillPath()
            Else
              StrokePath(Elements(iLoop)\Thickness * 5)
            EndIf         
            
          Case "Ellipse"
          
            AddPathEllipse(Elements(iLoop)\StartX,Elements(iLoop)\StartY, Elements(iLoop)\InnerRadius,Elements(iLoop)\OuterRadius)
            If Elements(iLoop)\Filled = #True
              FillPath()
            Else
              StrokePath(Elements(iLoop)\Thickness * 5)
            EndIf   
            
          
          Case "Line"

            If Path = #True
              AddPathLine(Elements(iLoop)\EndX,Elements(iLoop)\EndY)
            Else
              MovePathCursor(Elements(iLoop)\StartX,Elements(iLoop)\StartY)
              AddPathLine(Elements(iLoop)\EndX,Elements(iLoop)\EndY)
              If Elements(iLoop)\Round
                StrokePath(Elements(iLoop)\Thickness * 5,#PB_Path_RoundEnd)
              Else
                StrokePath(Elements(iLoop)\Thickness * 5)               
              EndIf
              
            EndIf          
        
          Case "Text"
  
            MovePathCursor(Left,Top)
            VFont = LoadFont(#PB_Any, Elements(iLoop)\Font, 8)
            VectorFont(FontID(VFont), Elements(iLoop)\Thickness * 5)
            Left = Elements(iLoop)\StartX - VectorTextWidth(Elements(iLoop)\Text)/2    
            Top = Elements(iLoop)\StartY - VectorTextHeight(Elements(iLoop)\Text)/2      
            MovePathCursor(Left,Top)
            
            If  Elements(iLoop)\Filled = #True
              DrawVectorText(Elements(iLoop)\Text)
            Else
              AddPathText(Elements(iLoop)\Text)
              StrokePath(1) 
            EndIf  
            
                
          Case "End"
            If Elements(iLoop)\Text = "Close"
              ClosePath()
            EndIf
            If Elements(iLoop)\Filled = #True
              FillPath()
            Else
              StrokePath(Elements(iLoop)\Thickness * 5,#PB_Path_RoundEnd|#PB_Path_RoundCorner)
            EndIf
            Path = #False
        
          Case "VArc"
        
            If Path = #True
              VDraw::AddPathArc(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\MidX1,Elements(iLoop)\MidY1,Elements(iLoop)\OuterRadius)
            Else
              MovePathCursor(Elements(iLoop)\StartX,Elements(iLoop)\StartY)
              VDraw::AddPathArc(Elements(iLoop)\MidX1,Elements(iLoop)\MidY1,Elements(iLoop)\EndX,Elements(iLoop)\EndY,Elements(iLoop)\OuterRadius)
              If Elements(iLoop)\Filled = #True
                FillPath()
              Else
                StrokePath(Elements(iLoop)\Thickness * 5)
              EndIf           
            EndIf        
            
          Case "Clock Arrow"
            DrawArrowClock(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\Filled,Elements(iLoop)\StartAngle) 
            
          Case "Curved Arrow"
            DrawArrowCur(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\Filled,Elements(iLoop)\StartAngle) 
            
          Case "Straight Arrow"
            DrawArrowStr(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\EndX,Elements(iLoop)\EndY,Elements(iLoop)\StartAngle) 
            
          Case "UndoRedo"
            DrawUndoRedo(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\StartAngle) 
            
           Case "Flash"
            DrawFlash(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\StartAngle) 
           
          Case "Magnifier"
            DrawMagnifier(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\StartAngle) 
       
          Case "Moon"
            DrawMoon(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\StartAngle) 
            
           Case "Pen"

            DrawPen(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\Trans,Elements(iLoop)\StartAngle)
            
          Case "Plus"
            DrawPlusSign(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius)
          
          Case "Poly"
            
           DrawPolyGon(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\Points,Elements(iLoop)\StartAngle,Elements(iLoop)\OuterRadius,Elements(iLoop)\Filled,Elements(iLoop)\Thickness * 5,Elements(iLoop)\Round,Elements(iLoop)\Colour)
            
          Case "Warning"

            DrawWarning(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius,Elements(iLoop)\Trans,Elements(iLoop)\StartAngle)
            
          Case "Star"
          
            DrawStar(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\Points,Elements(iLoop)\OuterRadius,Elements(iLoop)\InnerRadius,Elements(iLoop)\Thickness,Elements(iLoop)\Filled)
          
        Case "Tick"
          
          DrawTick(Elements(iLoop)\StartX,Elements(iLoop)\StartY,Elements(iLoop)\OuterRadius)
        
       Case "Start"
        
          Path = #True
          MovePathCursor(Elements(iLoop)\StartX,Elements(iLoop)\StartY)
          
        Default

      EndSelect
    Next  
  EndIf

  StopVectorDrawing()  
 
EndProcedure

  Procedure DrawShape(Destination.s)
    
    Define iLoop.i = 0
    Define Path.i = #False
    Define k.i
  
    If Destination = "Icon"
      StartVectorDrawing(ImageVectorOutput(AppMain::IconImg))  
      DrawIcon()
      AppMain::GreyScale = #True
      StartVectorDrawing(ImageVectorOutput(AppMain::IconGreyImg))  
      DrawIcon()       
      AppMain::GreyScale = #False      
    Else
      StartVectorDrawing(CanvasVectorOutput(AppMain::drgCanvas))
      ;Clearcanvas
      DrawVectorImage(ImageID(AppMain::EmptyImg), 255)  
      DrawIcon()       
    EndIf

EndProcedure

  Procedure NewGroup()
    
    Define Criteria.s
    
    Criteria = "Select * FROM Groups WHERE Name = '" + NewGroup::Name + "';"
    If DatabaseQuery(AppMain::ShapesDB, Criteria)
      If FirstDatabaseRow(AppMain::ShapesDB) = 0
        Criteria = "INSERT INTO Groups (Name)" +
                   " VALUES('" + NewGroup::Name + "');"
        DatabaseUpdate(AppMain::ShapesDB,Criteria)
      Else
        MessageRequester("Groups","Group Exists",#PB_MessageRequester_Ok)
      EndIf
    EndIf
      
  EndProcedure

  Procedure EventHandler(Event)
  
    Select Event
        
      Case #PB_Event_CloseWindow 
        End
      
      Case #PB_Event_Menu
        
        Select EventMenu()
   
          Case #mnuIconNewGroup
          
            NewGroup::Open()
            If NewGroup::OkPressed = #True
              NewGroup()
            EndIf
          
          Case #mnuIconNewIcon
            
            NewShape::Open()
            If NewShape::OkPressed = #True
              SelectedShape_id =  NewShape()
              CurrentIcon = NewShape::Name
              LoadElements()
              ShowElements()
              DrawShape("Canvas")
              ShowIcons() 
              AppMain::ShapeLoaded = #True           
            EndIf          
            
          Case #mnuIconLoad
            LoadIcon::Open()
            If LoadIcon::OkPressed = #True
              SelectedShape_id = LoadIcon::SelectedShapeID
              LoadElements()
              ShowElements()
              DrawShape("Canvas")
              ShowIcons() 
              AppMain::ShapeLoaded = #True
              DisableMenuItem(0, #mnuIconSave, #False) 
            EndIf          
          
          Case #mnuIconSave
            Save()
          
          Case #mnuIconViewSave
            ViewIconWindow = IconView::Open() 
            ShowIcons()
          
          Case #mnuIconExit
            ;Close The Programme
            End
          
          Case #mnuDrawArc
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Arc")
              DrawArc::NewArc()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf 
          
          Case #mnuDrawBox
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Box")
              DrawBox::NewBox()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf
          
          Case #mnuDrawCircle
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Circle")
              DrawCircle::NewCircle()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf
          
          Case #mnuDrawCurve
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Curve")
              DrawCurve::NewCurve()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf         
          
          Case #mnuDrawEllipse
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Ellipse")
              DrawEllipse::NewEllipse()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf         
          
          Case #mnuDrawLine
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Line")
              DrawLine::NewLine()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf
          
          Case #mnuDrawText
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Text")
              DrawText::NewText()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf         
           
          Case #mnuDrawArrowStr  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("ArrowStr")
              DrawArrowStr::NewArrowStr()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf          
           
          Case #mnuDrawArrowClock  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("ArrowClk")
              DrawArrowClock::NewArrowClock()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf          
            
          Case #mnuDrawArrowCur  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("ArrowCur")
              DrawArrowCur::NewArrowCur()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf          
           
          Case #mnuDrawUndoRedo
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("UndoRedo") 
              DrawUndoRedo::NewUndoRedo()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf         
            
           Case #mnuDrawFlash  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Flash")
              DrawFlash::NewFlash()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf           
            
          Case #mnuDrawMagnifier  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Magnifier")
              DrawMagnifier::NewMagnifier()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf
            
          Case #mnuDrawMoon  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Moon")
              DrawMoon::NewMoon()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf          
            
          Case #mnuDrawPen  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Pen")
              DrawPen::NewPen()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf         
            
          Case #mnuDrawPlus  
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Plus")
              DrawPlus::NewPlusSign()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf  
          
          Case #mnuDrawPoly
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Poly")
              DrawPoly::NewPoly()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf 
          
          Case #mnuDrawStar
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Star")
              DrawStar::NewStar()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf 
          
          Case #mnuDrawTick
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Tick")
              DrawTick::NewTick()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf   
         
          Case #mnuDrawWarning
            If AppMain::ShapeLoaded = #True
              AppMain::Drawmode = "Add"
              EditGadgets("Warning")
              DrawWarning::NewWarning()
            Else
              MessageRequester("Icon Designer","No Icon Loaded",#PB_MessageRequester_Ok|#PB_MessageRequester_Error)
            EndIf           
            
          Case #mnuHelpShow          
            HelpWindow = HelpViewer::Open("Topic") 
         
        EndSelect

      Case #PB_Event_Gadget
        
        Select EventGadget()
          
            
          Case spnTrans
          
            ;Show selected transparency in colour display if it exists
            SelectedColour = RGBA(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour),GetGadgetState(spnTrans)) 
            If IsGadget(cnvColour)
              SetColour(SelectedColour)
            EndIf
        
          Case btnColour
          
            ;Call ColourRequester with current colour
            Colour = ColorRequester(RGB(Red(SelectedColour),Green(SelectedColour),Blue(SelectedColour)))
            If Colour > -1
              SelectedColour = RGBA(Red(Colour),Green(Colour),Blue(Colour),GetGadgetState(spnTrans))  
              SetColour(SelectedColour)
            EndIf
          
          Case btnNext
            
            If CurrentElement < ArraySize(Elements())
              CurrentElement = CurrentElement + 1
            EndIf
            ShowElements()
 
          Case btnPrevious
          
            If CurrentElement > 0
              CurrentElement = CurrentElement - 1
            EndIf
            ShowElements()          
          
          Case btnFont
            FontName$ = "" 
            FontRequester(FontName$, FontSize,0)
            Elements(CurrentElement)\Font = SelectedFontName()           
            VFont = LoadFont(#PB_Any, Elements(CurrentElement)\Font, Elements(CurrentElement)\Thickness)
            
          Case btnRedraw 
          
            ;Colour Allways Used
            Elements(CurrentElement)\Colour = SelectedColour          
          
            ;Select Case on type
            Select Elements(CurrentElement)\Type
                
              Case "Arc"

                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
                Elements(CurrentElement)\OuterRadius  = Val(GetGadgetText(strRadius)) 
                If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf
                Elements(CurrentElement)\StartAngle = GetGadgetState(spnAngle1)
                Elements(CurrentElement)\EndAngle = GetGadgetState(spnAngle2)              
              
              Case "Box"
              
                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
                Elements(CurrentElement)\EndX = Val(GetGadgetText(strEndX))
                Elements(CurrentElement)\EndY = Val(GetGadgetText(strEndY)) 
                If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf 
              
              Case "Circle"
              
                Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))
                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
                If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf
              
             Case "Curve"
              
                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
                Elements(CurrentElement)\MidX1 = Val(GetGadgetText(strMidX1))
                Elements(CurrentElement)\MidY1 = Val(GetGadgetText(strMidY1))    
                Elements(CurrentElement)\MidX2 = Val(GetGadgetText(strMidX2))
                Elements(CurrentElement)\MidY2 = Val(GetGadgetText(strMidY2))               
                Elements(CurrentElement)\EndX = Val(GetGadgetText(strEndX))
                Elements(CurrentElement)\EndY = Val(GetGadgetText(strEndY))  
               
              Case "Ellipse"
              
                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
                Elements(CurrentElement)\InnerRadius = Val(GetGadgetText(strXRadius))            
                Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strYRadius)) 
              
                If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf
              
              Case "Line"
         
                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
                Elements(CurrentElement)\EndX = Val(GetGadgetText(strEndX))
                Elements(CurrentElement)\EndY = Val(GetGadgetText(strEndY))               
                Elements(CurrentElement)\Round = GetGadgetState(chkRound)   
              
              Case "Text"
              
                Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
                Elements(CurrentElement)\Text = GetGadgetText(strtext)
                If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf            
                
                Case "Clock Arrow"
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
                Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))
                Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle))     
                If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf             
                
              Case "Curved Arrow"
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
                Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))
                Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle))     
                 If GetGadgetState(optFill) = #True
                  Elements(CurrentElement)\Filled = #True
                Else
                  Elements(CurrentElement)\Filled = #False
                EndIf
                
              Case "Straight Arrow"
                Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
                Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
                Elements(CurrentElement)\EndX = Val(GetGadgetText(strEndX))
                Elements(CurrentElement)\EndY = Val(GetGadgetText(strEndY))              
                Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle))     
                
             Case "UndoRedo"
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle))              
                
             Case "Flash"
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))            
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle)) 
               
             Case "Magnifier"
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))            
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle)) 
               
             Case "Moon"
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))            
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle)) 
               
             Case "Pen"
               Elements(CurrentElement)\Trans = GetGadgetState(spnTrans)
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))              
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle))             
               
             Case "Plus"
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
              
             Case "Poly"
               Elements(CurrentElement)\Points = GetGadgetState(spnSides) 
               Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))            
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle)) 
               Elements(CurrentElement)\Round = GetGadgetState(chkRound) 
               If GetGadgetState(chkRound) = #True
                 Elements(CurrentElement)\Round = #True
               Else
                 Elements(CurrentElement)\Round = #False
               EndIf
               If GetGadgetState(optFill) = #True
                 Elements(CurrentElement)\Filled = #True
               Else
                 Elements(CurrentElement)\Filled = #False
               EndIf 
              
             Case "Star"

               Elements(CurrentElement)\Points = GetGadgetState(spnSides)           
               Elements(CurrentElement)\Thickness = GetGadgetState(spnThickness)
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strOuterRadius))            
               Elements(CurrentElement)\InnerRadius = Val(GetGadgetText(strInnerRadius))  
               If GetGadgetState(optFill) = #True
                 Elements(CurrentElement)\Filled = #True
               Else
                 Elements(CurrentElement)\Filled = #False
               EndIf             
              
             Case "Tick"
              
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))            

             Case "Warning"
               Elements(CurrentElement)\Trans = GetGadgetState(spnTrans)
               Elements(CurrentElement)\StartX = Val(GetGadgetText(strStartX))
               Elements(CurrentElement)\StartY = Val(GetGadgetText(strStartY))  
               Elements(CurrentElement)\OuterRadius = Val(GetGadgetText(strRadius))              
               Elements(CurrentElement)\StartAngle = Val(GetGadgetText(strAngle))
              
           EndSelect
        
           ;Redraw Whole Icon
           DrawShape("Canvas")
           ShowIcons() 
          
      EndSelect ;EventGadget()
      
    EndSelect ;Event
  
  EndProcedure

Procedure SaveElement(Type.s)

  ReDim Elements(NumberOfElements)
  
  ;Element being saved becomes current element for display in edit area
  currentelement = NumberOfElements
  
  Elements(NumberOfElements)\Type = Type
  Elements(NumberOfElements)\Text = AppMain::NewObject\Text
  Elements(NumberOfElements)\StartX = AppMain::NewObject\StartX
  Elements(NumberOfElements)\StartY = AppMain::NewObject\StartY
  Elements(NumberOfElements)\MidX1 = AppMain::NewObject\MidX1
  Elements(NumberOfElements)\MidY1 = AppMain::NewObject\MidY1
  Elements(NumberOfElements)\MidX2 = AppMain::NewObject\MidX2
  Elements(NumberOfElements)\MidY2 = AppMain::NewObject\MidY2   
  Elements(NumberOfElements)\EndX = AppMain::NewObject\EndX
  Elements(NumberOfElements)\EndY = AppMain::NewObject\EndY
  Elements(NumberOfElements)\OuterRadius = AppMain::NewObject\OuterRadius
  Elements(NumberOfElements)\InnerRadius = AppMain::NewObject\InnerRadius
  Elements(NumberOfElements)\StartAngle = AppMain::NewObject\StartAngle
  Elements(NumberOfElements)\EndAngle = AppMain::NewObject\EndAngle 
  Elements(NumberOfElements)\Colour = AppMain::NewObject\Colour  
  Elements(NumberOfElements)\Thickness = AppMain::NewObject\Thickness
  Elements(NumberOfElements)\Filled = AppMain::NewObject\Filled
  Elements(NumberOfElements)\Points = AppMain::NewObject\Points
  Elements(NumberOfElements)\Font = AppMain::NewObject\Font
  Elements(NumberOfElements)\Trans = AppMain::NewObject\Trans
  Elements(NumberOfElements)\Round = AppMain::NewObject\Round
  NumberOfElements = NumberOfElements + 1 
  ShowElements()
EndProcedure

;Main Programme Start

;Create Image To Display Icons
AppMain::BlankImg = CreateImage(#PB_Any, 640,640, 32,#PB_Image_Transparent)
AppMain::EmptyImg = CreateImage(#PB_Any, 640,640, 32,RGB(255,255,255))
AppMain::IconGreyImg = CreateImage(#PB_Any, 640,640, 32,#PB_Image_Transparent)
AppMain::Drawmode = "Idle"

MainWnd = OpenWindow(#PB_Any, 0, 0, 810, 680, "Vector Icon Designer", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
CreateMenu(0, WindowID(MainWnd))
  MenuTitle("Icon")
  OpenSubMenu("New")
  MenuItem(#mnuIconNewGroup, "Group")
  MenuItem(#mnuIconNewIcon, "Icon")
  CloseSubMenu()
  MenuItem(#mnuIconLoad, "Load")
  MenuItem(#mnuIconSave, "Save")
  MenuBar()
  MenuItem(#mnuIconViewSave, "View\Save Icons")
  MenuBar()
  MenuItem(#mnuIconExit, "Exit")
  DisableMenuItem(0, #mnuIconSave, #True) 
  ;DisableMenuItem(0, #mnuIconViewSave, #True)  
  MenuTitle("Draw")
  OpenSubMenu("Elements")
    MenuItem(#mnuDrawArc, "Arc") 
    MenuItem(#mnuDrawBox, "Box") 
    MenuItem(#mnuDrawCircle, "Circle")  
    MenuItem(#mnuDrawCurve, "Curve")    
    MenuItem(#mnuDrawEllipse, "Ellipse")  
    MenuItem(#mnuDrawLine, "Line")
    MenuItem(#mnuDrawPath, "Path")  
    MenuItem(#mnuDrawText, "Text")   
  CloseSubMenu()
  OpenSubMenu("Shapes")  
    MenuItem(#mnuDrawArrowClock, "Clock Arrow") 
    MenuItem(#mnuDrawArrowCur, "Curved Arrow")   
    MenuItem(#mnuDrawArrowStr, "Straight Arrow")  
    MenuItem(#mnuDrawFlash, "Flash")    
    MenuItem(#mnuDrawMoon, "Moon") 
    MenuItem(#mnuDrawMagnifier, "Magnifying Glass") 
    MenuItem(#mnuDrawPen, "Pen")    
    MenuItem(#mnuDrawPoly, "PolyGon")
    MenuItem(#mnuDrawPlus, "Plus Sign")
    MenuItem(#mnuDrawStar, "Star")
    MenuItem(#mnuDrawTick, "Tick")   
    MenuItem(#mnuDrawUndoRedo,"Undo\Redo")    
    MenuItem(#mnuDrawWarning, "Warning")    
  CloseSubMenu()  
  MenuTitle("Help")
  MenuItem(#mnuHelpShow, "Show Help")  
AppMain::drgCanvas = CanvasGadget(#PB_Any, 10, 10, 640, 640)
txtCurrentIcon = TextGadget(#PB_Any, 660, 10, 140, 20, "Current Icon")
strCurrentIcon = StringGadget(#PB_Any, 660, 30, 140, 20, "")  
TextGadget(#PB_Any, 660, 60, 60, 20, "Element")
txtStatus = TextGadget(#PB_Any, 690, 80, 80, 20, " 0 Of 0 ", #PB_Text_Center)    
btnPrevious = ButtonGadget(#PB_Any, 660, 75, 25, 25, "<")
DisableGadget(btnPrevious,#True)
btnNext = ButtonGadget(#PB_Any, 775, 75, 25, 25, ">")
DisableGadget(btnNext,#True)
strType = StringGadget(#PB_Any, 660, 105, 140, 20, "")

;Container For element properties
AppMain::cntSubAddEdit = ContainerGadget(#PB_Any, 655, 205, 150, 50,#PB_Container_Single)
CloseGadgetList()
HideGadget(AppMain::cntSubAddEdit,#True)

OpenShapesDB()

;Main Message Loop
Repeat
  
  Event = WaitWindowEvent()
  
  Select EventWindow() 
      
    Case MainWnd

      EventHandler(Event)
      
    Case ViewIconWindow

      IconView::EventHandler(Event)
      If Not IsWindow(ViewIconWindow)
        ViewIconWindow = #Null
      EndIf
      
    Case HelpWindow

      HelpViewer::EventHandler(Event)
      
  EndSelect ;EventWindow() 

ForEver
EndModule

; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 810
; FirstLine = 584
; Folding = HjyGu+
; EnableXP